"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _PureComponent2 = _interopRequireDefault(require("./PureComponent"));

var _SampleZoomIndicator = _interopRequireDefault(require("./views/SampleZoomIndicator"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var React = require('react');

require('react-resizable/css/styles.css');

var getColumns = require('./views/Columns');

// Styles
require('./Columns.css'); // XXX switch to js styles


var compStyles = require('./Spreadsheet.module.css');

var getSpreadsheet = function getSpreadsheet(columnsWrapper) {
  var _class, _temp;

  var Columns = getColumns(columnsWrapper);
  return _temp = _class = /*#__PURE__*/function (_PureComponent) {
    (0, _inherits2["default"])(_class, _PureComponent);

    var _super = _createSuper(_class);

    function _class() {
      (0, _classCallCheck2["default"])(this, _class);
      return _super.apply(this, arguments);
    }

    (0, _createClass2["default"])(_class, [{
      key: "render",
      value: function render() {
        var _this$props = this.props,
            _this$props$appState = _this$props.appState,
            data = _this$props$appState.data,
            addColumnAddHover = _this$props$appState.addColumnAddHover,
            columns = _this$props$appState.columns,
            enableTransition = _this$props$appState.enableTransition,
            samples = _this$props$appState.samples,
            zoom = _this$props$appState.zoom,
            children = _this$props.children,
            otherProps = (0, _objectWithoutProperties2["default"])(_this$props, ["appState", "children"]);
        return /*#__PURE__*/React.createElement("div", {
          className: compStyles.Spreadsheet
        }, zoom.count < samples.length ? /*#__PURE__*/React.createElement(_SampleZoomIndicator["default"], {
          column: columns.samples,
          addColumnAddHover: addColumnAddHover,
          enableTransition: enableTransition,
          data: data.samples,
          samples: samples,
          zoom: zoom
        }) : null, /*#__PURE__*/React.createElement(Columns, (0, _extends2["default"])({
          appState: this.props.appState
        }, otherProps), children));
      }
    }]);
    return _class;
  }(_PureComponent2["default"]), (0, _defineProperty2["default"])(_class, "displayName", 'Spreadsheet'), _temp;
};

module.exports = getSpreadsheet;