"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _PureComponent2 = _interopRequireDefault(require("../PureComponent"));

var _TiesPlaceholder = _interopRequireDefault(require("../views/TiesPlaceholder"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var React = require('react');

var pick = require('../underscore_ext')["default"].pick;

var TiesContainer = /*#__PURE__*/function (_PureComponent) {
  (0, _inherits2["default"])(TiesContainer, _PureComponent);

  var _super = _createSuper(TiesContainer);

  function TiesContainer() {
    var _this;

    (0, _classCallCheck2["default"])(this, TiesContainer);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onAddTerm", function (term) {
      _this.props.callback(['ties-add-term', term]);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onKeepRow", function (index, keep) {
      _this.props.callback(['ties-keep-row', index, keep]);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onShowDoc", function (index) {
      _this.props.callback(['ties-show-doc', index]);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onHideDoc", function () {
      _this.props.callback(['ties-hide-doc']);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onPage", function (page) {
      _this.props.callback(['ties-set-page', page]);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onCreateColumn", function () {
      console.log('onCreateColumn FIXME'); // getColSpec, blah blah
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onDismiss", function () {
      _this.props.callback(['ties-dismiss']);
    });
    return _this;
  }

  (0, _createClass2["default"])(TiesContainer, [{
    key: "render",
    value: function render() {
      var handlers = pick(this, ['onAddTerm', 'onKeepRow', 'onShowDoc', 'onHideDoc', 'onPage', 'onCreateColumn', 'onDismiss']);
      return /*#__PURE__*/React.createElement(_TiesPlaceholder["default"], (0, _extends2["default"])({
        state: this.props.appState
      }, handlers));
    }
  }]);
  return TiesContainer;
}(_PureComponent2["default"]);

(0, _defineProperty2["default"])(TiesContainer, "displayName", 'TiesContainer');
var _default = TiesContainer;
exports["default"] = _default;