"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _PureComponent2 = _interopRequireDefault(require("../PureComponent"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var React = require('react');

var widgets = require('../columnWidgets');

var _ = require('../underscore_ext')["default"]; // XXX doing layout here.
// XXX we could push width down into widgets.legend, but would
// need to update all the legend components to respect width.


function addLegend(Component) {
  var _class, _temp;

  return _temp = _class = /*#__PURE__*/function (_PureComponent) {
    (0, _inherits2["default"])(_class, _PureComponent);

    var _super = _createSuper(_class);

    function _class() {
      (0, _classCallCheck2["default"])(this, _class);
      return _super.apply(this, arguments);
    }

    (0, _createClass2["default"])(_class, [{
      key: "render",
      value: function render() {
        var _this$props = this.props,
            children = _this$props.children,
            props = (0, _objectWithoutProperties2["default"])(_this$props, ["children"]),
            _this$props$appState = this.props.appState,
            editing = _this$props$appState.editing,
            columns = _this$props$appState.columns,
            columnData = _this$props$appState.data;
        return /*#__PURE__*/React.createElement(Component, props, React.Children.map(children, function (el) {
          var id = el.props['data-actionKey'],
              data = columnData[id],
              column = columns[id];
          return /*#__PURE__*/React.createElement("div", {
            "data-actionKey": id
          }, el, id != null && editing !== id && !_.isNumber(id) ? /*#__PURE__*/React.createElement("div", {
            style: {
              width: column.width
            }
          }, widgets.legend({
            column: column,
            id: id,
            data: data
          })) : null);
        }));
      }
    }]);
    return _class;
  }(_PureComponent2["default"]), (0, _defineProperty2["default"])(_class, "displayName", 'SpreadsheetLegend'), _temp;
}

module.exports = addLegend;