var _extends = require("@babel/runtime/helpers/extends");

var _objectWithoutProperties = require("@babel/runtime/helpers/objectWithoutProperties");

var _classCallCheck = require("@babel/runtime/helpers/classCallCheck");

var _createClass = require("@babel/runtime/helpers/createClass");

var _assertThisInitialized = require("@babel/runtime/helpers/assertThisInitialized");

var _inherits = require("@babel/runtime/helpers/inherits");

var _possibleConstructorReturn = require("@babel/runtime/helpers/possibleConstructorReturn");

var _getPrototypeOf = require("@babel/runtime/helpers/getPrototypeOf");

var _defineProperty = require("@babel/runtime/helpers/defineProperty");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var React = require('react');

var VizSettings = require('../views/VizSettings');

var _ = require('../underscore_ext')["default"];

var vizSettingsState = ['defaultNormalization', 'colorClass', 'vizSettings', 'valueType', 'fieldType'];

function vizSettingsSelector(appState, columnId) {
  return _.pick(_.getIn(appState, ['columns', columnId]), vizSettingsState);
}

function addVizEditor(Component) {
  var _class, _temp;

  return _temp = _class = /*#__PURE__*/function (_React$Component) {
    "use strict";

    _inherits(_class, _React$Component);

    var _super = _createSuper(_class);

    function _class() {
      var _this;

      _classCallCheck(this, _class);

      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      _this = _super.call.apply(_super, [this].concat(args));

      _defineProperty(_assertThisInitialized(_this), "onHideViz", function () {
        _this.props.onOpenVizSettings(null);
      });

      return _this;
    }

    _createClass(_class, [{
      key: "render",
      value: function render() {
        // XXX appState?
        var _this$props = this.props,
            onVizSettings = _this$props.onVizSettings,
            componentProps = _objectWithoutProperties(_this$props, ["onVizSettings"]),
            appState = componentProps.appState,
            openVizSettings = appState.openVizSettings,
            data = appState.data[openVizSettings],
            column = appState.columns[openVizSettings],
            units = appState.columns[openVizSettings] && appState.columns[openVizSettings].units;

        return /*#__PURE__*/React.createElement(Component, componentProps, this.props.children, openVizSettings ? /*#__PURE__*/React.createElement(VizSettings, _extends({
          id: openVizSettings,
          onRequestHide: this.onHideViz,
          onVizSettings: onVizSettings,
          data: data,
          column: column,
          units: units
        }, vizSettingsSelector(appState, openVizSettings))) : null);
      }
    }]);

    return _class;
  }(React.Component), _defineProperty(_class, "displayName", 'SpreadsheetVizSettings'), _temp;
}

module.exports = addVizEditor;