var _classCallCheck = require("@babel/runtime/helpers/classCallCheck");

var _createClass = require("@babel/runtime/helpers/createClass");

var _inherits = require("@babel/runtime/helpers/inherits");

var _possibleConstructorReturn = require("@babel/runtime/helpers/possibleConstructorReturn");

var _getPrototypeOf = require("@babel/runtime/helpers/getPrototypeOf");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

/**
 * UCSC Xena Client
 * http://xena.ucsc.edu
 *
 * Xena footer, writes itself into the element with ID "footer" in page.template.
 */
// Core dependencies, components
var React = require('react');

var ReactDOM = require('react-dom'); // Styles


var compStyles = require('./footer.module.css');

var Footer = /*#__PURE__*/function (_React$Component) {
  "use strict";

  _inherits(Footer, _React$Component);

  var _super = _createSuper(Footer);

  function Footer() {
    _classCallCheck(this, Footer);

    return _super.apply(this, arguments);
  }

  _createClass(Footer, [{
    key: "render",
    value: function render() {
      return /*#__PURE__*/React.createElement("div", {
        className: compStyles.footer
      }, /*#__PURE__*/React.createElement("div", {
        className: compStyles.footerLinks
      }, /*#__PURE__*/React.createElement("ul", null, /*#__PURE__*/React.createElement("li", null, /*#__PURE__*/React.createElement("a", {
        href: "https://www.ucsc.edu/",
        target: "_blank"
      }, "UCSC")), /*#__PURE__*/React.createElement("li", null, /*#__PURE__*/React.createElement("a", {
        href: "https://ucscgenomics.soe.ucsc.edu/",
        target: "_blank"
      }, "UCSC Genomics Institute")), /*#__PURE__*/React.createElement("li", null, /*#__PURE__*/React.createElement("a", {
        href: "https://cgl.genomics.ucsc.edu/",
        target: "_blank"
      }, "UCSC Computational Genomics Laboratory")), /*#__PURE__*/React.createElement("li", null, /*#__PURE__*/React.createElement("a", {
        href: "http://xena.ucsc.edu/",
        target: "_blank"
      }, "UCSC Xena"))), /*#__PURE__*/React.createElement("ul", null, /*#__PURE__*/React.createElement("li", null, /*#__PURE__*/React.createElement("a", {
        href: "mailto:genome-cancer@soe.ucsc.edu"
      }, "Email")), /*#__PURE__*/React.createElement("li", null, /*#__PURE__*/React.createElement("a", {
        href: "https://twitter.com/ucscxena",
        target: "_blank"
      }, "Twitter")), /*#__PURE__*/React.createElement("li", null, /*#__PURE__*/React.createElement("a", {
        href: "https://github.com/ucscXena",
        target: "_blank"
      }, "Github")))), /*#__PURE__*/React.createElement("div", {
        className: compStyles.footerCR
      }, "Copyright \xA9 2016, The Regents of the University of California, Santa Cruz All. Rights Reserved. Apache-2.0 license."));
    }
  }]);

  return Footer;
}(React.Component);

var footer = document.getElementById('footer');
ReactDOM.render( /*#__PURE__*/React.createElement(Footer, null), footer);