"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireDefault(require("react"));

var _lib = require("react-toolbox/lib");

var _ImportPageModule = _interopRequireDefault(require("./ImportPage.module.css"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var style = {
  next: {
    "float": 'right',
    color: 'rgb(33, 33, 33)',
    marginLeft: '20px'
  },
  cancel: {
    "float": 'right',
    display: 'inline-block'
  },
  buttons: {
    paddingTop: '20px'
  }
};

var WizardSection = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(WizardSection, _React$Component);

  var _super = _createSuper(WizardSection);

  function WizardSection() {
    (0, _classCallCheck2["default"])(this, WizardSection);
    return _super.apply(this, arguments);
  }

  (0, _createClass2["default"])(WizardSection, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          isLast = _this$props.isLast,
          isFirst = _this$props.isFirst,
          nextEnabled = _this$props.nextEnabled,
          onImport = _this$props.onImport,
          fileName = _this$props.fileName,
          showRetry = _this$props.showRetry,
          showSuccess = _this$props.showSuccess,
          showAdvancedNextLabel = _this$props.showAdvancedNextLabel;
      var showNext = !isLast && !onImport && !showRetry;
      var showBack = !isFirst && !showSuccess;
      return /*#__PURE__*/_react["default"].createElement("div", null, fileName && /*#__PURE__*/_react["default"].createElement("p", null, /*#__PURE__*/_react["default"].createElement("b", null, "File to Import: ", fileName)), this.props.children, /*#__PURE__*/_react["default"].createElement("div", {
        className: _ImportPageModule["default"].wizardButtons
      }, /*#__PURE__*/_react["default"].createElement(_lib.Button, {
        label: "Back",
        raised: true,
        style: {
          visibility: showBack ? 'visible' : 'hidden'
        },
        onClick: this.props.onPreviousPage
      }), showNext && /*#__PURE__*/_react["default"].createElement(_lib.Button, {
        label: 'Next',
        raised: true,
        style: style.next,
        accent: nextEnabled,
        disabled: !nextEnabled,
        onClick: this.props.onNextPage
      }), !!onImport && /*#__PURE__*/_react["default"].createElement(_lib.Button, {
        label: "Import",
        raised: true,
        style: style.next,
        accent: nextEnabled,
        disabled: !nextEnabled,
        onClick: onImport
      }), showAdvancedNextLabel && /*#__PURE__*/_react["default"].createElement(_lib.Button, {
        label: 'Advanced',
        raised: true,
        style: style.next,
        disabled: !nextEnabled,
        onClick: this.props.onNextPage
      }), showRetry && this.renderRetryButtons(), showSuccess && this.renderSuccessButtons(), !showSuccess && /*#__PURE__*/_react["default"].createElement(CancelButton, {
        onCancelImport: this.props.onCancelImport
      })));
    }
  }, {
    key: "renderRetryButtons",
    value: function renderRetryButtons() {
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: _ImportPageModule["default"].retryButtons
      }, /*#__PURE__*/_react["default"].createElement(_lib.Button, {
        label: "Edit Data Details",
        raised: true,
        style: style.next,
        accent: true,
        onClick: this.props.onRetryMetadata
      }), /*#__PURE__*/_react["default"].createElement(_lib.Button, {
        label: "Reload file",
        raised: true,
        style: style.retryButton,
        accent: true,
        onClick: this.props.onRetryFile
      }), !!this.props.showLoadWithWarnings && /*#__PURE__*/_react["default"].createElement(_lib.Button, {
        label: "Load with warnings",
        raised: true,
        style: style.next,
        accent: true,
        onClick: this.props.onLoadWithWarnings
      }));
    }
  }, {
    key: "renderSuccessButtons",
    value: function renderSuccessButtons() {
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: _ImportPageModule["default"].retryButtons
      }, /*#__PURE__*/_react["default"].createElement(_lib.Button, {
        label: "Finish",
        raised: true,
        style: style.next,
        accent: true,
        onClick: this.props.onFinish
      }), /*#__PURE__*/_react["default"].createElement(_lib.Button, {
        label: "Load more data",
        raised: true,
        style: style.next,
        accent: true,
        onClick: this.props.onImportMoreData
      }), /*#__PURE__*/_react["default"].createElement(_lib.Button, {
        label: "View data",
        raised: true,
        style: style.next,
        accent: true,
        onClick: this.props.onViewData
      }));
    }
  }]);
  return WizardSection;
}(_react["default"].Component);

exports["default"] = WizardSection;
;

var CancelButton = /*#__PURE__*/function (_React$Component2) {
  (0, _inherits2["default"])(CancelButton, _React$Component2);

  var _super2 = _createSuper(CancelButton);

  function CancelButton() {
    var _this;

    (0, _classCallCheck2["default"])(this, CancelButton);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super2.call.apply(_super2, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "state", {
      active: false
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onToggle", function () {
      _this.setState({
        active: !_this.state.active
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "actions", function () {
      return [{
        label: 'No, I want to continue',
        onClick: _this.onToggle,
        style: {
          color: '#377937'
        }
      }, {
        label: 'Yes, cancel import',
        onClick: _this.props.onCancelImport,
        style: {
          color: '#c95252'
        }
      }];
    });
    return _this;
  }

  (0, _createClass2["default"])(CancelButton, [{
    key: "render",
    value: function render() {
      var active = this.state.active;
      return /*#__PURE__*/_react["default"].createElement("div", {
        style: style.cancel
      }, /*#__PURE__*/_react["default"].createElement(_lib.Dialog, {
        actions: this.actions(),
        active: active,
        onEscKeyDown: this.onToggle,
        onOverlayClick: this.onToggle,
        title: "Are you sure you want to cancel import process ?"
      }, "Current progress will be lost"), /*#__PURE__*/_react["default"].createElement(_lib.Button, {
        onClick: this.onToggle,
        flat: true,
        style: {
          backgroundColor: '#f7f7f7'
        }
      }, "Cancel"));
    }
  }]);
  return CancelButton;
}(_react["default"].Component);