var _ = require('./underscore_ext')["default"];

var Rx = require('./rx')["default"]; // XXX Should also do a takeUntil componentWillUnmount, perhaps
// via rx-react.


var rxEvents = function rxEvents(comp) {
  var ev = {};
  comp.on = {};

  for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    args[_key - 1] = arguments[_key];
  }

  _.each(args, function (name) {
    var sub = new Rx.Subject();
    ev[name] = sub;
    comp.on[name] = sub.next.bind(sub);
  });

  return ev;
};

module.exports = {
  rxEvents: rxEvents
};