"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _colorScales = require("../colorScales");

require("../../css/transcript_css/nameColumn.css");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var React = require('react');

var contrastColor = require('../color_helper')["default"].contrastColor;

var styles = require('./NameColumn.module.css');

var NameColumn = /*#__PURE__*/function (_React$PureComponent) {
  (0, _inherits2["default"])(NameColumn, _React$PureComponent);

  var _super = _createSuper(NameColumn);

  function NameColumn() {
    (0, _classCallCheck2["default"])(this, NameColumn);
    return _super.apply(this, arguments);
  }

  (0, _createClass2["default"])(NameColumn, [{
    key: "render",
    value: function render() {
      var data = this.props.data || {},
          gene = this.props.gene;
      var colors = (0, _colorScales.colorScale)(['ordinal', data.length]);
      var items = data.map(function (d, index) {
        var rowClass = d.zoom ? "nameColumn--item--zoom" : "nameColumn--item";
        return /*#__PURE__*/React.createElement("div", {
          key: d.name,
          className: styles[rowClass],
          style: {
            backgroundColor: colors(index),
            color: contrastColor(colors(index))
          }
        }, /*#__PURE__*/React.createElement("span", null, /*#__PURE__*/React.createElement("i", null, gene, " ", d.name)));
      }); //height of each row has been set to 70px

      return /*#__PURE__*/React.createElement("div", {
        className: styles.nameColumn
      }, items);
    }
  }]);
  return NameColumn;
}(React.PureComponent);

module.exports = NameColumn;