"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _PureComponent2 = _interopRequireDefault(require("../PureComponent"));

var _ajaxLoader = _interopRequireDefault(require("../ajax-loader.gif"));

var _menu = require("react-toolbox/lib/menu");

var _tooltip = _interopRequireDefault(require("react-toolbox/lib/tooltip"));

var _refGeneExons = require("../refGeneExons");

var _geneLabelAnnotation = require("../geneLabelAnnotation");

var _staticIntervalTree = require("static-interval-tree");

var _cursor = _interopRequireDefault(require("./cursor.png"));

var _GeneSetViewDialog = require("./GeneSetViewDialog");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var React = require('react');

var _ = require('../underscore_ext')["default"];

var DefaultTextInput = require('./DefaultTextInput');

var DragSelect = require('./DragSelect');

var SpreadSheetHighlight = require('../SpreadSheetHighlight');

var ResizeOverlay = require('./ResizeOverlay');

var widgets = require('../columnWidgets');

var columnZoom = require('../columnZoom');

var aboutDatasetMenu = require('./aboutDatasetMenu');

var mutationVector = require('../models/mutationVector'); //var ValidatedInput = require('./ValidatedInput');


var konami = require('../konami');

var Crosshair = require('./Crosshair');

var parsePos = require('../parsePos');

var _require = require('../colorScales'),
    categoryMore = _require.categoryMore;

var _require2 = require('../defaultServers'),
    publicServers = _require2.publicServers;

var ColCard = require('./ColCard');

var _require3 = require('../ChromPosition'),
    ChromPosition = _require3.ChromPosition;

var gaEvents = require('../gaEvents');

var ZoomHelpTag = require('./ZoomHelpTag');

var ZoomOverlay = require('./ZoomOverlay');

var config = require('../config');

var ESCAPE = 27;

var IconMenu = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(IconMenu, _React$Component);

  var _super = _createSuper(IconMenu);

  function IconMenu() {
    var _this;

    (0, _classCallCheck2["default"])(this, IconMenu);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onKeyDown", function (ev) {
      if (ev.keyCode === ESCAPE) {
        _this.ref.handleMenuHide();
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onHide", function () {
      var onHide = _this.props.onHide;

      _this.cleanup();

      onHide && onHide();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onShow", function () {
      var onShow = _this.props.onShow;
      _this.curtain = document.createElement('div');
      _this.curtain.style = "position:absolute;top:0;left:0;width:100%;height:100%";
      document.body.appendChild(_this.curtain);
      document.addEventListener('keydown', _this.onKeyDown, false);
      onShow && onShow();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onRef", function (ref) {
      _this.ref = ref;
    });
    return _this;
  }

  (0, _createClass2["default"])(IconMenu, [{
    key: "cleanup",
    value: function cleanup() {
      // We get an onHide() call from setting state in Menu, *and*
      // from this.ref.handleMenuHide(), during this.onKeyDown. So,
      // check if 'curtain' still exists before tear down.
      if (this.curtain) {
        document.body.removeChild(this.curtain);
        document.removeEventListener('keydown', this.onKeyDown);
        delete this.curtain;
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.cleanup();
    }
  }, {
    key: "render",
    value: function render() {
      var others = _.omit(this.props, 'onShow', 'onHide');

      return /*#__PURE__*/React.createElement(_menu.IconMenu, (0, _extends2["default"])({
        innerRef: this.onRef,
        onShow: this.onShow,
        onHide: this.onHide
      }, others));
    }
  }]);
  return IconMenu;
}(React.Component);

function uniqueNotNull(data) {
  return _.uniq(data).filter(function (f) {
    return f !== null;
  });
}

var TooltipMenuItem = (0, _tooltip["default"])(_menu.MenuItem);

var tooltipConfig = function tooltipConfig(message) {
  return {
    tooltipDelay: 750,
    tooltip: message,
    tooltipPosition: "horizontal",
    style: {
      pointerEvents: 'all'
    }
  };
}; // XXX move this?


function download(_ref) {
  var _ref2 = (0, _slicedToArray2["default"])(_ref, 2),
      fields = _ref2[0],
      rows = _ref2[1];

  var txt = _.map([fields].concat(rows), function (row) {
    return row.join('\t');
  }).join('\n'); // use blob for bug in chrome: https://code.google.com/p/chromium/issues/detail?id=373182


  var url = URL.createObjectURL(new Blob([txt], {
    type: 'text/tsv'
  }));
  var a = document.createElement('a');
  var filename = 'xenaDownload.tsv';

  _.extend(a, {
    id: filename,
    download: filename,
    href: url
  });

  document.body.appendChild(a);
  a.click();
  document.body.removeChild(a);
}

function downloadJSON(downloadData) {
  // use blob for bug in chrome: https://code.google.com/p/chromium/issues/detail?id=373182
  var url = URL.createObjectURL(new Blob([JSON.stringify(downloadData
  /*, undefined, 4*/
  )], {
    type: 'text/json'
  }));
  var a = document.createElement('a');
  var filename = 'xenaDownload.json';

  _.extend(a, {
    id: filename,
    download: filename,
    href: url
  });

  document.body.appendChild(a);
  a.click();
  document.body.removeChild(a);
}

var annotationHeight = 47,
    positionHeight = 17,
    scaleHeight = 12;
var styles = {
  status: {
    pointerEvents: 'none',
    textAlign: 'center',
    zIndex: 1,
    position: 'absolute',
    top: 0,
    left: 0,
    width: '100%',
    height: '100%',
    backgroundColor: 'rgba(255, 255, 255, 0.6)'
  },
  error: {
    textAlign: 'center',
    pointerEvents: 'all',
    cursor: 'pointer'
  }
}; // Manually set focus to avoid triggering dropdown (close) or anchor
// (navigate) actions.

/*var setFocus = ev => {
	ev.preventDefault();
	ev.stopPropagation();
	ev.target.focus();
};

var stopPropagation = ev => ev.stopPropagation();
*/

var addIdsToArr = function addIdsToArr(arr) {
  var list = arr.filter(function (el) {
    return el;
  }).map(function (el, id) {
    return React.cloneElement(el, {
      key: id
    });
  });
  return _.isEmpty(list) ? null : list;
};

var isIntString = function isIntString(str) {
  return !!str.trim().replace(/,/g, '').match(/^[0-9]+$/);
};

var parseExtendedInt = function parseExtendedInt(str) {
  return parseInt(str.trim().replace(/,/g, ''), 10);
};

var boundIsValid = _.curry(function (maxXZoom, str) {
  if (!maxXZoom) {
    return false; // no data
  }

  if (str.trim() === '') {
    return true;
  }

  if (!isIntString(str)) {
    // must be an int if it's not empty string
    return false;
  }

  var pos = parseExtendedInt(str);
  return maxXZoom.start <= pos && pos <= maxXZoom.end;
});
/*function zoomMenu(props) {
	var {column} = props,
		{xzoom, maxXZoom, assembly} = column,
		{start, end} = xzoom || maxXZoom || {start: 0, end: 0},
		bIV = boundIsValid(maxXZoom);
	return [
		<MenuItem header style={{fontSize: '80%'}}>Start position ( {assembly} )</MenuItem>,
		<MenuItem>
			<ValidatedInput defaultValue={start} isValid={bIV} ref='start' onSelect={stopPropagation} onClick={setFocus} type='text' bsSize='small' />
		</MenuItem>,
		<MenuItem header style={{fontSize: '80%'}}>End position ( {assembly} )</MenuItem>,
		<MenuItem>
			<ValidatedInput defaultValue={end} isValid={bIV} ref='end' onSelect={stopPropagation} onClick={setFocus} type='text' bsSize='small' />
		</MenuItem>];
}*/


function sortVisibleLabel(column, pos) {
  var sortVisible = _.get(column, 'sortVisible', true);

  return sortVisible ? pos ? 'Sort by full region avg' : 'Sort by gene average' : 'Sort by zoom region avg';
}

function segmentedVizOptions(onVizOptions) {
  return onVizOptions ? [/*#__PURE__*/React.createElement(_menu.MenuDivider, null), /*#__PURE__*/React.createElement(_menu.MenuItem, {
    onSelect: onVizOptions,
    "data-renderer": "line",
    caption: "Line"
  }), /*#__PURE__*/React.createElement(_menu.MenuItem, {
    onSelect: onVizOptions,
    "data-renderer": "pixel",
    caption: "Pixel"
  }), /*#__PURE__*/React.createElement(_menu.MenuItem, {
    onSelect: onVizOptions,
    "data-renderer": "power",
    caption: "Power"
  }), /*#__PURE__*/React.createElement(_menu.MenuDivider, null)] : [];
}

function segmentedMenu(props, _ref3) {
  var onShowIntrons = _ref3.onShowIntrons,
      onSortVisible = _ref3.onSortVisible,
      onSpecialDownload = _ref3.onSpecialDownload,
      onVizOptions = _ref3.onVizOptions;
  var column = props.column,
      data = props.data,
      pos = parsePos(column.fields[0]),
      _column$showIntrons = column.showIntrons,
      showIntrons = _column$showIntrons === void 0 ? false : _column$showIntrons,
      noData = !_.get(data, 'req'),
      sortVisibleItemName = sortVisibleLabel(column, pos),
      intronsItemName = showIntrons ? 'Hide introns' : "Show introns",
      specialDownloadItemName = 'Download segments';
  return addIdsToArr([].concat((0, _toConsumableArray2["default"])(pos ? [] : [/*#__PURE__*/React.createElement(_menu.MenuItem, {
    disabled: noData,
    onClick: onShowIntrons,
    caption: intronsItemName
  })]), (0, _toConsumableArray2["default"])(segmentedVizOptions(onVizOptions)), [
  /*#__PURE__*/
  //...(xzoomable ? zoomMenu(props, {onSortVisible}) : []),
  React.createElement(_menu.MenuItem, {
    disabled: noData,
    onClick: onSortVisible,
    caption: sortVisibleItemName
  }), /*#__PURE__*/React.createElement(_menu.MenuItem, {
    disabled: noData,
    onClick: onSpecialDownload,
    caption: specialDownloadItemName
  })]));
}

function mutationMenu(props, _ref4) {
  var onMuPit = _ref4.onMuPit,
      onShowIntrons = _ref4.onShowIntrons,
      onSortVisible = _ref4.onSortVisible;
  var column = props.column,
      data = props.data,
      pos = parsePos(column.fields[0]),
      valueType = column.valueType,
      sortVisible = column.sortVisible,
      assembly = column.assembly,
      _column$showIntrons2 = column.showIntrons,
      showIntrons = _column$showIntrons2 === void 0 ? false : _column$showIntrons2,
      rightValueType = valueType === 'mutation',
      wrongDataSubType = column.fieldType !== 'mutation',
      rightAssembly = ["hg19", "hg38", "GRCh37", "GRCh38"].indexOf(assembly) !== -1 ? true : false,
      noMuPit = !rightValueType || !rightAssembly || !!wrongDataSubType || !!pos,
      noData = !_.get(data, 'req'),
      mupitItemName = noData ? 'MuPIT 3D Loading' : 'MuPIT 3D (' + assembly + ' coding)',
      sortVisibleItemName = sortVisible ? 'Sort using full region' : 'Sort using zoom region',
      intronsItemName = showIntrons ? 'Hide introns' : "Show introns",
      mupitMenuItem = null;

  if (data && !_.isEmpty(data.refGene)) {
    mupitMenuItem = pos ? /*#__PURE__*/React.createElement(TooltipMenuItem, (0, _extends2["default"])({
      disabled: noMuPit
    }, tooltipConfig("Only available for gene view"), {
      caption: mupitItemName
    })) : noMuPit ? /*#__PURE__*/React.createElement(TooltipMenuItem, (0, _extends2["default"])({
      disabled: noMuPit
    }, tooltipConfig("Only available for SNPs on hg19 and hg38"), {
      caption: mupitItemName
    })) : /*#__PURE__*/React.createElement(_menu.MenuItem, {
      onClick: function onClick(e) {
        return onMuPit(assembly, e);
      },
      caption: mupitItemName
    });
  }

  return addIdsToArr([mupitMenuItem, pos ? null : /*#__PURE__*/React.createElement(_menu.MenuItem, {
    disabled: noData,
    onClick: onShowIntrons,
    caption: intronsItemName
  }),
  /*#__PURE__*/
  //...(xzoomable ? zoomMenu(props, {onSortVisible}) : []),
  React.createElement(_menu.MenuItem, {
    disabled: noData,
    onClick: onSortVisible,
    caption: sortVisibleItemName
  })]);
}

var isSig = function isSig(column) {
  return column.fetchType === 'signature';
};

function tumorMapCompatible(column) {
  var fieldType = column.fieldType,
      dsID = column.dsID,
      fields = column.fields; // link to tumorMap from any public xena hub columns
  // data be queried directly from xena

  var foundPublicHub = dsID && publicServers.indexOf(JSON.parse(dsID).host) !== -1; // The intent is to support anything that can be queried as a single value
  // with (xena-query {:select}). Here 'fields' is the fields or probes list.
  // We can only send a single probe, so check for length 1. Note in
  // particular the case of an ensembl genes probemap, which is a geneProbes
  // column with probe list of one, which is supported.
  // We can't support gene average, so no 'genes' columns.

  if (!foundPublicHub || ['geneProbes', 'probes', 'clinical'].indexOf(fieldType) === -1 || isSig(column) || fields.length !== 1) {
    return false;
  }

  return true;
}

var isChrom = function isChrom(column) {
  return parsePos(_.get(column.fieldList || column.fields, 0), _.getIn(column, ['assembly']));
}; // Maybe put in a selector.


var supportsGeneAverage = function supportsGeneAverage(column) {
  return !isChrom(column) && !isSig(column) && _.contains(['geneProbes', 'genes'], column.fieldType) && (column.fieldList || column.fields).length === 1;
}; // Duplicated in denseMatrix.js, because of the weirdness with
// fields vs. probes.


var supportsClustering = function supportsClustering(_ref5) {
  var fieldType = _ref5.fieldType,
      fields = _ref5.fields;
  return _.contains(['genes', 'probes', 'geneProbes'], fieldType) && fields.length > 2;
};

function matrixMenu(props, _ref6) {
  var onTumorMap = _ref6.onTumorMap,
      thisTumorMap = _ref6.thisTumorMap,
      onMode = _ref6.onMode,
      onCluster = _ref6.onCluster;
  var column = props.column,
      fieldType = column.fieldType,
      clustering = column.clustering,
      supportTumorMap = thisTumorMap && tumorMapCompatible(column),
      order = clustering == null ? 'Cluster' : 'Uncluster';
  return addIdsToArr([supportsClustering(column) ? /*#__PURE__*/React.createElement(_menu.MenuItem, {
    onClick: onCluster,
    caption: order,
    disabled: config.singlecell
  }) : null, supportsGeneAverage(column) ? fieldType === 'genes' ? /*#__PURE__*/React.createElement(_menu.MenuItem, {
    onClick: function onClick(e) {
      return onMode(e, 'geneProbes');
    },
    caption: "Detailed view"
  }) : /*#__PURE__*/React.createElement(_menu.MenuItem, {
    onClick: function onClick(e) {
      return onMode(e, 'genes');
    },
    caption: "Gene average"
  }) : null, supportTumorMap ? /*#__PURE__*/React.createElement(_menu.MenuItem, {
    onClick: function onClick(e) {
      return onTumorMap(thisTumorMap, e);
    },
    caption: "Tumor Map"
  }) : null]);
} // We could try to drive this from the column widgets, but it gets rather complex making
// the widgets care about a menu in their container.


function optionMenu(props, opts) {
  var valueType = props.column.valueType;
  return (valueType === 'mutation' ? mutationMenu : valueType === 'segmented' ? segmentedMenu : matrixMenu)(props, opts);
}

function getStatusView(status, onReload) {
  if (status === 'loading') {
    return /*#__PURE__*/React.createElement("div", {
      "data-xena": "loading",
      style: styles.status
    }, /*#__PURE__*/React.createElement("img", {
      style: {
        textAlign: 'center'
      },
      src: _ajaxLoader["default"]
    }));
  }

  if (status === 'error') {
    return /*#__PURE__*/React.createElement("div", {
      style: styles.status
    }, /*#__PURE__*/React.createElement("i", {
      onClick: onReload,
      style: styles.error,
      title: "Error loading data. Click to reload.",
      "aria-hidden": "true",
      className: 'material-icons'
    }, "warning"));
  }

  return null;
}

function getPosition(maxXZoom, pStart, pEnd) {
  if (!boundIsValid(maxXZoom, pStart) || !boundIsValid(maxXZoom, pEnd)) {
    return false;
  }

  var _ref7 = pStart < pEnd ? [pStart, pEnd] : [pEnd, pStart],
      _ref8 = (0, _slicedToArray2["default"])(_ref7, 2),
      start = _ref8[0],
      end = _ref8[1];

  start = start.trim() === '' ? maxXZoom.start : parseExtendedInt(start);
  end = end.trim() === '' ? maxXZoom.end : parseExtendedInt(end);
  return maxXZoom.start <= start && start <= end && end <= maxXZoom.end ? {
    start: start,
    end: end
  } : null;
}

var specialDownloadMenu = false; //var annotationHelpText =  'Drag zoom. Shift-click zoom out.';

if (process.env.NODE_ENV !== 'production') {
  specialDownloadMenu = true;
} // For geneProbes we will average across probes to compute KM. For
// other types, we can't support multiple fields.


function disableKM(column, hasSurvival) {
  if (!hasSurvival) {
    return [true, 'No survival data for cohort'];
  } // XXX need to refactor column.fields & column.fieldList


  if ((column.fieldList || column.fields).length > 1) {
    return [true, 'Unsupported for multiple genes/ids'];
  }

  return [false, ''];
}

function disableChart(column) {
  if (_.contains(['mutation', 'SV'], column.fieldType)) {
    return true;
  }

  return false;
}

function getCodingVariants(index, exons) {
  var resultSet = new Set();
  exons.forEach(function (_ref9) {
    var _ref10 = (0, _slicedToArray2["default"])(_ref9, 2),
        start = _ref10[0],
        end = _ref10[1];

    (0, _staticIntervalTree.matches)(index, {
      start: start,
      end: end
    }).forEach(function (item) {
      return resultSet.add(item.variant);
    });
  });
  return (0, _toConsumableArray2["default"])(resultSet);
}

function filterExonsByCDS(exonStarts, exonEnds, cdsStart, cdsEnd) {
  return _.zip(exonStarts, exonEnds).filter(function (_ref11) {
    var _ref12 = (0, _slicedToArray2["default"])(_ref11, 2),
        start = _ref12[0],
        end = _ref12[1];

    return !(end < cdsStart || start > cdsEnd);
  }).map(function (_ref13) {
    var _ref14 = (0, _slicedToArray2["default"])(_ref13, 2),
        start = _ref14[0],
        end = _ref14[1];

    return [Math.max(start, cdsStart), Math.min(end, cdsEnd)];
  });
}

var geneHeight = function geneHeight() {
  return annotationHeight + scaleHeight + 4;
};

var showPosition = function showPosition(column) {
  return _.contains(['segmented', 'mutation', 'SV', 'geneProbes'], column.fieldType) && _.getIn(column, ['dataset', 'probemapMeta', 'dataSubType']) !== 'regulon';
};

var showGeneLabel = function showGeneLabel(column) {
  return _.contains(['genes', 'probes', 'clinical'], column.fieldType) || column.fieldType === 'geneProbes' && _.getIn(column, ['dataset', 'probemapMeta', 'dataSubType']) === 'regulon';
}; // Drag mapped to: direction, samples start, samples end, indicator start, indicator end (where indicator is either
// annotation or sample zoom), offset x, offset y, samples height
// Select mapped to: direction, data start and data end


var zoomTranslateSelection = function zoomTranslateSelection(props, selection, zone) {
  var column = props.column,
      yZoom = props.zoom,
      crosshair = selection.crosshair,
      start = selection.start,
      end = selection.end,
      offset = selection.offset,
      fieldType = column.fieldType,
      annotated = showPosition(column),
      direction = columnZoom.direction({
    fieldType: fieldType,
    start: start,
    end: end,
    zone: zone
  }),
      startEndPx = columnZoom.startEndPx({
    direction: direction,
    start: start,
    end: end
  }),
      overlay = columnZoom.overlay(_objectSpread(_objectSpread({
    annotated: annotated,
    column: column,
    direction: direction,
    fieldType: fieldType
  }, startEndPx), {}, {
    zone: zone
  })),
      zoomTo = columnZoom.zoomTo(_objectSpread(_objectSpread({
    annotated: annotated,
    column: column,
    direction: direction,
    fieldType: fieldType
  }, overlay), {}, {
    yZoom: yZoom
  }));
  return {
    crosshair: crosshair,
    direction: direction,
    offset: offset,
    overlay: overlay,
    zone: zone,
    zoomTo: zoomTo
  };
};

var Column = /*#__PURE__*/function (_PureComponent) {
  (0, _inherits2["default"])(Column, _PureComponent);

  var _super2 = _createSuper(Column);

  function Column() {
    var _this2;

    (0, _classCallCheck2["default"])(this, Column);

    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    _this2 = _super2.call.apply(_super2, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "state", {
      dragZoom: {},
      subColumnIndex: {},
      specialDownloadMenu: specialDownloadMenu,
      showGeneSetWizard: false,
      geneSetUrl: undefined
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "enableHiddenFeatures", function () {
      specialDownloadMenu = true;

      _this2.setState({
        specialDownloadMenu: true
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "toggleInteractive", function (interactive) {
      _this2.props.onInteractive('zoom', interactive);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "onMouseMove", function (e) {
      var column = _this2.props.column,
          width = column.width,
          subColumnIndex = _this2.state.subColumnIndex;

      if (!_.isEmpty(subColumnIndex)) {
        var aveSize = subColumnIndex.aveSize,
            laneNum = Math.ceil(column.fields.length / (width / aveSize)),
            subColumnWidth = width / column.fields.length;

        if (laneNum <= _geneLabelAnnotation.maxLane) {
          var offsetX = e.clientX - e.currentTarget.getBoundingClientRect().left,
              index = Math.floor(offsetX / subColumnWidth);

          _this2.setState({
            subColumnIndex: _objectSpread(_objectSpread({}, _this2.state.subColumnIndex), {}, {
              index: index,
              mousing: true
            })
          });
        }
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "onMouseOut", function () {
      var subColumnIndex = _this2.state.subColumnIndex;

      if (!_.isEmpty(subColumnIndex)) {
        _this2.setState({
          subColumnIndex: _objectSpread(_objectSpread({}, _this2.state.subColumnIndex), {}, {
            index: -1,
            mousing: false
          })
        });
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "initSubColumnIndex", function () {
      var column = _this2.props.column;

      if (_.contains(['probes', 'genes'], column.fieldType) || _.getIn(column, ['dataset', 'probemapMeta', 'dataSubType']) === 'regulon') {
        var aveSize = _geneLabelAnnotation.geneLableFont * (column.fields.reduce(function (total, x) {
          return total + (x ? x.length : 0);
        }, 0) / column.fields.length);

        _this2.setState({
          subColumnIndex: {
            index: -1,
            aveSize: aveSize,
            mousing: false
          }
        });
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "onResizeStop", function (size) {
      _this2.props.onResize(_this2.props.id, size);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "onRemove", function () {
      _this2.props.onRemove(_this2.props.id);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "onDownload", function () {
      var _this2$props = _this2.props,
          column = _this2$props.column,
          data = _this2$props.data,
          samples = _this2$props.samples,
          index = _this2$props.index,
          sampleFormat = _this2$props.sampleFormat;
      gaEvents('spreadsheet', 'download', 'column');
      download(widgets.download({
        column: column,
        data: data,
        samples: samples,
        index: index,
        sampleFormat: sampleFormat
      }));
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "onViz", function () {
      _this2.props.onViz(_this2.props.id);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "onEdit", function () {
      _this2.props.onEdit(_this2.props.id);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "onKm", function () {
      gaEvents('spreadsheet', 'km');

      _this2.props.onKm(_this2.props.id);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "onChart", function () {
      gaEvents('spreadsheet', 'columnChart-open');

      _this2.props.onChart(_this2.props.id);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "canDoGeneSetComparison", function () {
      var _this2$props2 = _this2.props,
          _this2$props2$column = _this2$props2.column,
          fieldType = _this2$props2$column.fieldType,
          valueType = _this2$props2$column.valueType,
          heatmap = _this2$props2$column.heatmap,
          codes = _this2$props2.data.codes,
          name = _this2$props2.cohort.name;

      if (fieldType !== 'clinical' || valueType !== 'coded' || !codes || codes.length < 2 || _GeneSetViewDialog.AVAILABLE_GENESET_COHORTS.indexOf(name) < 0) {
        return false;
      }

      return uniqueNotNull(heatmap[0]).length === 2;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "hideGeneSetWizard", function () {
      _this2.setState({
        showGeneSetWizard: false
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "showGeneSetComparison", function () {
      var _this2$props3 = _this2.props,
          _this2$props3$column = _this2$props3.column,
          heatmap = _this2$props3$column.heatmap,
          codes = _this2$props3$column.codes,
          name = _this2$props3.cohort.name;
      var heatmapData = heatmap[0].filter(function (f) {
        return f !== null;
      });
      var heatmapCodes = uniqueNotNull(heatmapData);

      var heatmapLookup = _.invert(heatmapCodes);

      var sampleData = _.map(_this2.props.samples, _this2.props.sampleFormat);

      var subCohortData = [[], []];
      var heatmapLabels = [codes[heatmapCodes[0]], codes[heatmapCodes[1]]];

      for (var d in heatmapData) {
        subCohortData[heatmapLookup[heatmapData[d]]].push(sampleData[d]);
      }

      var subCohortA = "subCohortSamples1=".concat(name, ":").concat(heatmapLabels[0], ":").concat(subCohortData[0], "&selectedSubCohorts1=").concat(heatmapLabels[0], "&cohort1Color=").concat(categoryMore[heatmapCodes[0]]);
      var subCohortB = "subCohortSamples2=".concat(name, ":").concat(heatmapLabels[1], ":").concat(subCohortData[1], "&selectedSubCohorts2=").concat(heatmapLabels[1], "&cohort2Color=").concat(categoryMore[heatmapCodes[1]]); // const ROOT_URL = 'https://xenademo.berkeleybop.io/xena/#';
      // const ROOT_URL = 'http://localhost:3000/#';

      var finalUrl = "".concat(_GeneSetViewDialog.GENESETS_VIEWER_URL, "cohort=").concat(name, "&wizard=analysis&").concat(subCohortA, "&").concat(subCohortB);

      _this2.setState({
        geneSetUrl: "".concat(finalUrl),
        showGeneSetWizard: true,
        onHide: _this2.hideGeneSetWizard
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "onSortDirection", function () {
      var newDir = _.get(_this2.props.column, 'sortDirection', 'forward') === 'forward' ? 'reverse' : 'forward';

      _this2.props.onSortDirection(_this2.props.id, newDir);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "onMode", function (ev, newMode) {
      _this2.props.onMode(_this2.props.id, newMode);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "onColumnLabel", function (value) {
      _this2.props.onColumnLabel(_this2.props.id, value);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "onFieldLabel", function (value) {
      _this2.props.onFieldLabel(_this2.props.id, value);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "onShowIntrons", function () {
      _this2.props.onShowIntrons(_this2.props.id);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "onCluster", function () {
      _this2.props.onCluster(_this2.props.id, _this2.props.column.clustering ? undefined : 'probes', _this2.props.data);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "onDragZoom", function (selection, zone) {
      _this2.toggleInteractive(false);

      var translatedSelection = zoomTranslateSelection(_this2.props, selection, zone);

      _this2.setState({
        dragZoom: {
          selection: translatedSelection
        }
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "onDragZoomSelect", function (selection, zone) {
      _this2.toggleInteractive(true);

      var _this2$props4 = _this2.props,
          id = _this2$props4.id,
          onXZoom = _this2$props4.onXZoom,
          onYZoom = _this2$props4.onYZoom,
          zoom = _this2$props4.zoom,
          translatedSelection = zoomTranslateSelection(_this2.props, selection, zone),
          h = translatedSelection.direction === 'h',
          zoomTo = translatedSelection.zoomTo;

      _this2.setState({
        dragZoom: {}
      });

      h ? onXZoom(id, {
        start: zoomTo.start,
        end: zoomTo.end
      }) : onYZoom(_.merge(zoom, zoomTo));
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "onSortVisible", function () {
      var _this2$props5 = _this2.props,
          id = _this2$props5.id,
          column = _this2$props5.column;

      var value = _.get(column, 'sortVisible', column.valueType === 'segmented' ? true : false);

      _this2.props.onSortVisible(id, !value);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "onSpecialDownload", function () {
      var _this2$props6 = _this2.props,
          column = _this2$props6.column,
          data = _this2$props6.data,
          samples = _this2$props6.samples,
          index = _this2$props6.index,
          sampleFormat = _this2$props6.sampleFormat,
          _widgets$specialDownl = widgets.specialDownload({
        column: column,
        data: data,
        samples: samples,
        index: index,
        sampleFormat: sampleFormat
      }),
          type = _widgets$specialDownl.type,
          downloadData = _widgets$specialDownl.downloadData;

      if (type === "txt") {
        download(downloadData);
      } else if (type === "json") {
        downloadJSON(downloadData);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "onXZoomClear", function () {
      var _this2$props7 = _this2.props,
          id = _this2$props7.id,
          maxXZoom = _this2$props7.column.maxXZoom,
          onXZoom = _this2$props7.onXZoom,
          position = getPosition(maxXZoom, '', '');
      onXZoom(id, position);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "onMenuToggle", function (open) {
      var xzoomable = _this2.state.xzoomable,
          _this2$props8 = _this2.props,
          _this2$props8$column = _this2$props8.column,
          xzoom = _this2$props8$column.xzoom,
          maxXZoom = _this2$props8$column.maxXZoom,
          valueType = _this2$props8$column.valueType,
          onXZoom = _this2$props8.onXZoom,
          id = _this2$props8.id;

      if (xzoomable && !open && ['mutation', 'segmented'].indexOf(valueType) !== -1) {
        var start = _this2.refs.start.getValue(),
            end = _this2.refs.end.getValue(),
            position = getPosition(maxXZoom, start, end);

        if (position && !_.isEqual(position, xzoom)) {
          onXZoom(id, position);
        }
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "onMuPit", function (assembly) {
      // Construct the url, which will be opened in new window
      // total = newRows.length,
      // k fixed at 1000
      // gene, protein, etc size is fixed at 1000
      // this could be actual size of protein or gene, but it is complicated due to mutations could be from exon region and display could be genomics region
      // for the same gene it is a constant, does it really matter to be different between genes?
      var k = 1000,
          indexByPos = _this2.props.index.byPosition,
          _$values$ = _.values(_this2.props.data.refGene)[0],
          exonStarts = _$values$.exonStarts,
          exonEnds = _$values$.exonEnds,
          cdsStart = _$values$.cdsStart,
          cdsEnd = _$values$.cdsEnd;

      var exons = filterExonsByCDS(exonStarts, exonEnds, cdsStart, cdsEnd),
          variants = getCodingVariants(indexByPos, exons); //coding variants

      var SNVPs = mutationVector.SNVPvalue(variants, variants.length, k);

      if (_this2.props.column.xzoom) {
        var _this2$props$column$x = _this2.props.column.xzoom,
            zoomStart = _this2$props$column$x.start,
            zoomEnd = _this2$props$column$x.end;
        SNVPs = _.filter(SNVPs, function (value) {
          var valueStart = parseInt(value.start);
          return valueStart >= zoomStart && valueStart <= zoomEnd;
        });
      }

      var uriList = _.map(SNVPs, function (n) {
        return "".concat(n.chr, ":").concat(n.start, ":").concat(1 - n.pValue);
      }).join(','),
          mupitUrl = {
        "hg19": 'http://hg19.cravat.us/MuPIT_Interactive?gm=',
        // mupit hg19 server
        "GRCh37": 'http://hg19.cravat.us/MuPIT_Interactive?gm=',
        // mupit hg19 server
        "hg38": 'http://mupit.icm.jhu.edu/MuPIT_Interactive?gm=',
        //mupit hg38 server
        "GRCh38": 'http://mupit.icm.jhu.edu/MuPIT_Interactive?gm=' //mupit hg38 server

      },
          url = mupitUrl[assembly];

      window.open(url + "".concat(uriList));
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "onTumorMap", function (tumorMap) {
      // TumorMap/Xena API https://tumormap.ucsc.edu/query/addAttributeXena.html
      var _this2$props9 = _this2.props,
          data = _this2$props9.data,
          column = _this2$props9.column,
          valueType = column.valueType,
          url = "https://tumormap.ucsc.edu/?xena=addAttr&p=" + tumorMap.map + "&layout=" + tumorMap.layout;

      var ds = JSON.parse(_this2.props.column.dsID),
          hub = ds.host,
          dataset = ds.name,
          feature = _this2.props.column.fields[0],
          // gene or probe
      customColors = _.getIn(column, ['colors', 0, 2]);

      url = url + "&hub=" + hub + "/data/";
      url = url + "&dataset=" + dataset;
      url = url + "&attr=" + feature;

      if (valueType === "coded") {
        var codes = _.getIn(data, ['codes']),
            cat,
            colorhex;

        _.map(codes, function (code, i) {
          cat = code;
          colorhex = customColors ? customColors[i] : categoryMore[i % categoryMore.length];
          colorhex = colorhex.slice(1, colorhex.length);
          url = url + "&cat=" + encodeURIComponent(cat);
          url = url + "&color=" + colorhex;
        });
      }

      window.open(url);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "onReload", function () {
      _this2.props.onReload(_this2.props.id);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "getControlWidth", function () {
      return 90; //		return 136;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this2), "onAbout", function (ev, host, dataset) {
      ev.preventDefault();

      _this2.props.onAbout(host, dataset);
    });
    return _this2;
  }

  (0, _createClass2["default"])(Column, [{
    key: "componentWillMount",
    value: function componentWillMount() {
      var asciiA = 65;
      this.ksub = konami(asciiA).subscribe(this.enableHiddenFeatures);
      this.initSubColumnIndex();
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.ksub.unsubscribe();
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var _this$props = this.props,
          first = _this$props.first,
          id = _this$props.id,
          label = _this$props.label,
          samples = _this$props.samples,
          samplesMatched = _this$props.samplesMatched,
          column = _this$props.column,
          index = _this$props.index,
          zoom = _this$props.zoom,
          data = _this$props.data,
          fieldFormat = _this$props.fieldFormat,
          sampleFormat = _this$props.sampleFormat,
          hasSurvival = _this$props.hasSurvival,
          searching = _this$props.searching,
          onClick = _this$props.onClick,
          tooltip = _this$props.tooltip,
          wizardMode = _this$props.wizardMode,
          onReset = _this$props.onReset,
          interactive = _this$props.interactive,
          append = _this$props.append,
          cohort = _this$props.cohort,
          tumorMap = _this$props.tumorMap,
          _this$state = this.state,
          specialDownloadMenu = _this$state.specialDownloadMenu,
          dragZoom = _this$state.dragZoom,
          subColumnIndex = _this$state.subColumnIndex,
          selection = dragZoom.selection,
          width = column.width,
          dataset = column.dataset,
          columnLabel = column.columnLabel,
          fieldLabel = column.fieldLabel,
          user = column.user,
          onMode = this.onMode,
          onTumorMap = this.onTumorMap,
          onMuPit = this.onMuPit,
          onCluster = this.onCluster,
          onShowIntrons = this.onShowIntrons,
          onSortVisible = this.onSortVisible,
          onSpecialDownload = this.onSpecialDownload,
          thisTumorMap = _.getIn(tumorMap, [cohort.name]),
          menu = optionMenu(this.props, {
        onMode: onMode,
        onMuPit: onMuPit,
        onTumorMap: onTumorMap,
        thisTumorMap: thisTumorMap,
        onShowIntrons: onShowIntrons,
        onSortVisible: onSortVisible,
        onCluster: onCluster,
        onSpecialDownload: onSpecialDownload,
        specialDownloadMenu: specialDownloadMenu,
        isSig: isSig
      }),
          geneZoomable = columnZoom.supportsGeneZoom(column),
          geneZoomed = columnZoom.geneZoomed(column),
          geneZoomPct = Math.round(columnZoom.geneZoomLength(column) / columnZoom.maxGeneZoomLength(column) * 100),
          _disableKM = disableKM(column, hasSurvival),
          _disableKM2 = (0, _slicedToArray2["default"])(_disableKM, 2),
          kmDisabled = _disableKM2[0],
          kmTitle = _disableKM2[1],
          chartDisabled = disableChart(column),
          canDoGeneSetComparison = this.canDoGeneSetComparison(),
          status = _.get(data, 'status'),
          refreshIcon = /*#__PURE__*/React.createElement("i", {
        className: "material-icons",
        onClick: onReset
      }, "close"),
          annotation = showPosition(column) ? /*#__PURE__*/React.createElement(_refGeneExons.RefGeneAnnotation, {
        id: id,
        column: column,
        position: _.getIn(column, ['layout', 'chrom', 0]),
        refGene: _.getIn(data, ['refGene'], {}),
        probePosition: column.position,
        tooltip: tooltip,
        layout: column.layout,
        height: annotationHeight,
        positionHeight: column.position ? positionHeight : 0,
        width: width,
        mode: isChrom(column) ? "coordinate" : _.getIn(column, ['showIntrons']) === true ? "geneIntron" : "geneExon"
      }) : null,
          scale = showPosition(column) ? /*#__PURE__*/React.createElement(ChromPosition, {
        layout: column.layout,
        width: width,
        scaleHeight: scaleHeight,
        mode: isChrom(column) ? "coordinate" : _.getIn(column, ['showIntrons']) === true ? "geneIntron" : "geneExon"
      }) : null,
          geneLabel = showGeneLabel(column) ? /*#__PURE__*/React.createElement(_geneLabelAnnotation.GeneLabelAnnotation, {
        width: width,
        height: annotationHeight + scaleHeight,
        list: column.fields,
        subColumnIndex: this.state.subColumnIndex
      }) : null; // FF 'button' tag will not emit 'mouseenter' events (needed for
      // tooltips) for children. We must use a different tag, e.g. 'label'.
      // Button and Dropdown.Toggle will allow overriding the tag.  However
      // Splitbutton will not pass props down to the underlying Button, so we
      // can't use Splitbutton.
      // XXX put position into a css module


      return /*#__PURE__*/React.createElement("div", {
        style: {
          width: width,
          position: 'relative'
        }
      }, this.state.geneSetUrl && /*#__PURE__*/React.createElement(_GeneSetViewDialog.GeneSetViewDialog, {
        showGeneSetWizard: this.state.showGeneSetWizard,
        geneSetUrl: this.state.geneSetUrl,
        onHide: this.hideGeneSetWizard
      }), /*#__PURE__*/React.createElement(ZoomOverlay, {
        geneHeight: geneHeight(),
        height: zoom.height,
        positionHeight: column.position ? positionHeight : 0,
        selection: selection
      }, /*#__PURE__*/React.createElement(ColCard, {
        colId: label,
        sortable: !first,
        title: /*#__PURE__*/React.createElement(DefaultTextInput, {
          disabled: !interactive,
          onChange: this.onColumnLabel,
          value: {
            "default": columnLabel,
            user: user.columnLabel
          }
        }),
        subtitle: /*#__PURE__*/React.createElement(DefaultTextInput, {
          disabled: !interactive,
          onChange: this.onFieldLabel,
          value: {
            "default": fieldLabel,
            user: user.fieldLabel
          }
        }),
        onClick: this.onXZoomClear,
        geneZoomPct: geneZoomPct,
        geneZoomed: geneZoomable && geneZoomed,
        controls: !interactive ? first ? refreshIcon : null : /*#__PURE__*/React.createElement("div", null, first ? null : /*#__PURE__*/React.createElement(IconMenu, {
          icon: "more_vert",
          menuRipple: true,
          iconRipple: false
        }, menu, menu && /*#__PURE__*/React.createElement(_menu.MenuDivider, null), /*#__PURE__*/React.createElement(_menu.MenuItem, {
          title: kmTitle,
          onClick: this.onKm,
          disabled: kmDisabled,
          caption: "Kaplan Meier Plot"
        }), /*#__PURE__*/React.createElement(_menu.MenuItem, {
          onClick: this.onChart,
          disabled: chartDisabled,
          caption: "Chart & Statistics"
        }), canDoGeneSetComparison && /*#__PURE__*/React.createElement(_menu.MenuItem, {
          onClick: this.showGeneSetComparison,
          caption: "Differential Geneset View"
        }), /*#__PURE__*/React.createElement(_menu.MenuItem, {
          onClick: this.onSortDirection,
          caption: "Reverse sort"
        }), /*#__PURE__*/React.createElement(_menu.MenuItem, {
          onClick: this.onDownload,
          caption: "Download"
        }), aboutDatasetMenu(this.onAbout, _.get(dataset, 'dsID')), /*#__PURE__*/React.createElement(_menu.MenuItem, {
          onClick: this.onViz,
          caption: "Display"
        }), /*#__PURE__*/React.createElement(_menu.MenuItem, {
          disabled: !this.props.onEdit,
          onClick: this.onEdit,
          caption: "Edit"
        }), /*#__PURE__*/React.createElement(_menu.MenuItem, {
          onClick: this.onRemove,
          caption: "Remove"
        }))),
        wizardMode: wizardMode
      }, /*#__PURE__*/React.createElement("div", {
        style: {
          cursor: selection ? 'none' : annotation ? "url(".concat(_cursor["default"], ") 12 12, crosshair") : 'default',
          height: geneHeight()
        }
      }, /*#__PURE__*/React.createElement(DragSelect, {
        enabled: !wizardMode,
        onDrag: function onDrag(s) {
          return _this3.onDragZoom(s, 'a');
        },
        onSelect: function onSelect(s) {
          return _this3.onDragZoomSelect(s, 'a');
        }
      }, annotation ? /*#__PURE__*/React.createElement("div", null, scale, /*#__PURE__*/React.createElement("div", {
        style: {
          height: 2
        }
      }), annotation) : geneLabel)), /*#__PURE__*/React.createElement(ResizeOverlay, {
        enable: interactive,
        onResizeStop: this.onResizeStop,
        width: width,
        minWidth: this.getControlWidth,
        height: zoom.height
      }, /*#__PURE__*/React.createElement(SpreadSheetHighlight, {
        animate: searching,
        width: width,
        height: zoom.height,
        samples: samples.slice(zoom.index, zoom.index + zoom.count),
        samplesMatched: samplesMatched
      }), /*#__PURE__*/React.createElement("div", {
        style: {
          position: 'relative'
        },
        onMouseMove: this.onMouseMove,
        onMouseOut: this.onMouseOut
      }, /*#__PURE__*/React.createElement(Crosshair, {
        frozen: !interactive || this.props.frozen,
        mousing: subColumnIndex.mousing,
        geneHeight: geneHeight(),
        height: zoom.height,
        selection: selection
      }, /*#__PURE__*/React.createElement(DragSelect, {
        enabled: !wizardMode,
        onDrag: function onDrag(s) {
          return _this3.onDragZoom(s, 's');
        },
        onSelect: function onSelect(s) {
          return _this3.onDragZoomSelect(s, 's');
        }
      }, widgets.column({
        ref: 'plot',
        id: id,
        column: column,
        data: data,
        index: index,
        zoom: zoom,
        samples: samples,
        onClick: onClick,
        fieldFormat: fieldFormat,
        sampleFormat: sampleFormat,
        tooltip: tooltip
      })), getStatusView(status, this.onReload), /*#__PURE__*/React.createElement(ZoomHelpTag, {
        column: column,
        selection: selection
      })))))), append);
    }
  }]);
  return Column;
}(_PureComponent2["default"]);

module.exports = Column;