var _classCallCheck = require("@babel/runtime/helpers/classCallCheck");

var _createClass = require("@babel/runtime/helpers/createClass");

var _inherits = require("@babel/runtime/helpers/inherits");

var _possibleConstructorReturn = require("@babel/runtime/helpers/possibleConstructorReturn");

var _getPrototypeOf = require("@babel/runtime/helpers/getPrototypeOf");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

/**
 * UCSC Xena Client
 * http://xena.ucsc.edu
 *
 * Standard Xena ghost variable select card, displaying during wizard setup.
 *
 * State
 * -----
 * title - Text displayed as title.
 * width - Width of card.
 */
// Core dependencies, components
var React = require('react'); // App dependencies


var CardAvatar = require('./CardAvatar'); // Styles


var compStyles = require('./GhostVariableSelect.module.css');

var GhostVariableSelect = /*#__PURE__*/function (_React$Component) {
  "use strict";

  _inherits(GhostVariableSelect, _React$Component);

  var _super = _createSuper(GhostVariableSelect);

  function GhostVariableSelect() {
    _classCallCheck(this, GhostVariableSelect);

    return _super.apply(this, arguments);
  }

  _createClass(GhostVariableSelect, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          title = _this$props.title,
          width = _this$props.width;
      return /*#__PURE__*/React.createElement("div", {
        className: compStyles.GhostVariableSelect,
        style: {
          width: width
        }
      }, /*#__PURE__*/React.createElement("div", {
        className: compStyles.headerContainer
      }, /*#__PURE__*/React.createElement(CardAvatar, null)), /*#__PURE__*/React.createElement("div", {
        className: compStyles.title
      }, title));
    }
  }]);

  return GhostVariableSelect;
}(React.Component);

module.exports = GhostVariableSelect;