var _slicedToArray = require("@babel/runtime/helpers/slicedToArray");

var _classCallCheck = require("@babel/runtime/helpers/classCallCheck");

var _createClass = require("@babel/runtime/helpers/createClass");

var _inherits = require("@babel/runtime/helpers/inherits");

var _possibleConstructorReturn = require("@babel/runtime/helpers/possibleConstructorReturn");

var _getPrototypeOf = require("@babel/runtime/helpers/getPrototypeOf");

var _defineProperty = require("@babel/runtime/helpers/defineProperty");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var React = require('react');

var _ = require('../underscore_ext')["default"]; // Styles


var compStyles = require('./Legend.module.css');

var nodata = {
  text: "null: no data",
  color: "#808080"
};

var Legend = /*#__PURE__*/function (_React$Component) {
  "use strict";

  _inherits(Legend, _React$Component);

  var _super = _createSuper(Legend);

  function Legend() {
    _classCallCheck(this, Legend);

    return _super.apply(this, arguments);
  }

  _createClass(Legend, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          labels = _this$props.labels,
          colors = _this$props.colors,
          titles = _this$props.titles,
          max = _this$props.max,
          labelheader = _this$props.labelheader,
          footnotes = _this$props.footnotes,
          _this$props$addBreake = _this$props.addBreakend,
          addBreakend = _this$props$addBreake === void 0 ? 0 : _this$props$addBreake,
          _this$props$addNullNo = _this$props.addNullNotation,
          addNullNotation = _this$props$addNullNo === void 0 ? 0 : _this$props$addNullNo,
          ellipsis = labels.length > max,
          items = _.map(_.last(_.zip(labels, colors, titles), max), function (_ref, i) {
        var _ref2 = _slicedToArray(_ref, 3),
            l = _ref2[0],
            c = _ref2[1],
            t = _ref2[2];

        return /*#__PURE__*/React.createElement("div", {
          key: i,
          title: t,
          className: compStyles.item
        }, /*#__PURE__*/React.createElement("div", {
          className: compStyles.colorBox,
          style: {
            backgroundColor: c
          }
        }), /*#__PURE__*/React.createElement("label", {
          className: compStyles.label
        }, l));
      }).reverse(),
          footnotesItems = footnotes ? footnotes.map(function (text, i) {
        return /*#__PURE__*/React.createElement("div", {
          key: i,
          className: compStyles.footnotes
        }, text);
      }) : null,
          breakend = /*#__PURE__*/React.createElement("div", {
        className: compStyles.item
      }, /*#__PURE__*/React.createElement("div", {
        className: compStyles.breakendBar
      }), /*#__PURE__*/React.createElement("label", {
        className: compStyles.label
      }, "breakend")),
          nullNotation = /*#__PURE__*/React.createElement("div", {
        title: nodata.text
      }, /*#__PURE__*/React.createElement("label", {
        className: compStyles["null"],
        style: {
          backgroundColor: nodata.color
        }
      }, nodata.text));

      return /*#__PURE__*/React.createElement("div", {
        className: compStyles.Legend
      }, items ? /*#__PURE__*/React.createElement("div", {
        className: compStyles.column
      }, labelheader ? /*#__PURE__*/React.createElement("label", {
        className: compStyles.header
      }, labelheader) : null, items, addBreakend ? breakend : null, addNullNotation ? nullNotation : null) : null, ellipsis ? /*#__PURE__*/React.createElement("div", null, "...") : null, footnotes ? footnotesItems : null);
    }
  }]);

  return Legend;
}(React.Component);

_defineProperty(Legend, "defaultProps", {
  max: 40
});

module.exports = Legend;