var _defineProperty = require("@babel/runtime/helpers/defineProperty");

var _classCallCheck = require("@babel/runtime/helpers/classCallCheck");

var _createClass = require("@babel/runtime/helpers/createClass");

var _inherits = require("@babel/runtime/helpers/inherits");

var _possibleConstructorReturn = require("@babel/runtime/helpers/possibleConstructorReturn");

var _getPrototypeOf = require("@babel/runtime/helpers/getPrototypeOf");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

/**
 * UCSC Xena Client
 * http://xena.ucsc.edu
 *
 * Standard Xena spreadsheet status indicator. Displays label with state and,
 * additional actions to delete state.
 *
 */
// Core dependencies, components
var React = require('react'); // Styles


var classNames = require('classnames');

var compStyles = require('./SheetStatus.module.css');

var SheetStatus = /*#__PURE__*/function (_React$Component) {
  "use strict";

  _inherits(SheetStatus, _React$Component);

  var _super = _createSuper(SheetStatus);

  function SheetStatus() {
    _classCallCheck(this, SheetStatus);

    return _super.apply(this, arguments);
  }

  _createClass(SheetStatus, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          disabled = _this$props.disabled,
          label = _this$props.label,
          sheetState = _this$props.sheetState;
      return /*#__PURE__*/React.createElement("div", {
        className: classNames(compStyles.status, _defineProperty({}, compStyles.disabled, disabled), _defineProperty({}, compStyles.zoomAnimation, sheetState !== 'None'))
      }, label ? /*#__PURE__*/React.createElement("div", {
        className: compStyles.label
      }, label) : null, /*#__PURE__*/React.createElement("div", {
        className: compStyles.state
      }, sheetState));
    }
  }]);

  return SheetStatus;
}(React.Component);

module.exports = SheetStatus;