"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _reactAutosuggest = _interopRequireDefault(require("react-autosuggest"));

var _AutosuggestThemeModule = _interopRequireDefault(require("./AutosuggestTheme.module.css"));

var _XAutosuggestModule = _interopRequireDefault(require("./XAutosuggest.module.css"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var XAutosuggest = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(XAutosuggest, _React$Component);

  var _super = _createSuper(XAutosuggest);

  function XAutosuggest() {
    var _this;

    (0, _classCallCheck2["default"])(this, XAutosuggest);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "callInputRef", function (autosuggest) {
      var _this$props = _this.props,
          inputRef = _this$props.inputRef,
          autosuggestRef = _this$props.autosuggestRef;

      if (inputRef) {
        inputRef(autosuggest && autosuggest.input);
      }

      if (autosuggestRef) {
        autosuggestRef(autosuggest);
      }
    });
    return _this;
  }

  (0, _createClass2["default"])(XAutosuggest, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          value = _this$props2.value,
          onClear = _this$props2.onClear,
          autoProps = (0, _objectWithoutProperties2["default"])(_this$props2, ["value", "onClear"]);
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: _XAutosuggestModule["default"].XAutosuggest
      }, /*#__PURE__*/_react["default"].createElement(_reactAutosuggest["default"], (0, _extends2["default"])({}, autoProps, {
        ref: this.callInputRef,
        theme: _AutosuggestThemeModule["default"]
      })), value ? /*#__PURE__*/_react["default"].createElement("i", {
        className: "material-icons",
        onClick: onClear
      }, "close") : null);
    }
  }]);
  return XAutosuggest;
}(_react["default"].Component);

var _default = XAutosuggest;
exports["default"] = _default;