"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _PureComponent2 = _interopRequireDefault(require("../PureComponent"));

var _checkbox = require("react-toolbox/lib/checkbox");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var React = require('react');

var _ = require('../underscore_ext')["default"];

var XInputToolbar = require('./XInputToolbar');

var classNames = require('classnames'); // Styles


var compStyles = require('./XCheckboxGroup.module.css');

var XCheckboxGroup = /*#__PURE__*/function (_PureComponent) {
  (0, _inherits2["default"])(XCheckboxGroup, _PureComponent);

  var _super = _createSuper(XCheckboxGroup);

  function XCheckboxGroup() {
    var _this;

    (0, _classCallCheck2["default"])(this, XCheckboxGroup);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onChange", function (isOn, ev) {
      var value = ev.target.dataset.value;

      _this.props.onChange(value, isOn);
    });
    return _this;
  }

  (0, _createClass2["default"])(XCheckboxGroup, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          additionalAction = _this$props.additionalAction,
          label = _this$props.label,
          onAdditionalAction = _this$props.onAdditionalAction,
          options = _this$props.options,
          hideBadge = _this$props.hideBadge;
      return /*#__PURE__*/React.createElement("div", {
        className: classNames(compStyles.XCheckboxGroup, hideBadge && compStyles.hideBadge)
      }, /*#__PURE__*/React.createElement(XInputToolbar, {
        label: label,
        additionalAction: additionalAction,
        onAdditionalAction: onAdditionalAction
      }), _.map(options, function (group) {
        return [group.label ? /*#__PURE__*/React.createElement("span", {
          className: compStyles.subgroupHeader
        }, group.label) : null, _.map(group.options, function (o) {
          return /*#__PURE__*/React.createElement("span", null, /*#__PURE__*/React.createElement(_checkbox.Checkbox, {
            className: o.badge ? compStyles.withBadge : null,
            children: o.badge ? /*#__PURE__*/React.createElement("div", {
              className: compStyles.badge,
              style: o.badge.style
            }, o.badge.label) : [],
            "data-value": o.value,
            key: o.label,
            label: o.label,
            checked: o.checked,
            onChange: _this2.onChange
          }));
        })];
      }));
    }
  }]);
  return XCheckboxGroup;
}(_PureComponent2["default"]);

module.exports = XCheckboxGroup;