var _classCallCheck = require("@babel/runtime/helpers/classCallCheck");

var _createClass = require("@babel/runtime/helpers/createClass");

var _inherits = require("@babel/runtime/helpers/inherits");

var _possibleConstructorReturn = require("@babel/runtime/helpers/possibleConstructorReturn");

var _getPrototypeOf = require("@babel/runtime/helpers/getPrototypeOf");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

/**
 * UCSC Xena Client
 * http://xena.ucsc.edu
 *
 * Component for listing radio or checkbox meta data, when viewing advanced mode.
 */
// Core dependencies, components
var React = require('react');

var _ = require('../underscore_ext')["default"]; // Styles


var compStyles = require('./XRadioMeta.module.css');

var XRadioMeta = /*#__PURE__*/function (_React$Component) {
  "use strict";

  _inherits(XRadioMeta, _React$Component);

  var _super = _createSuper(XRadioMeta);

  function XRadioMeta() {
    _classCallCheck(this, XRadioMeta);

    return _super.apply(this, arguments);
  }

  _createClass(XRadioMeta, [{
    key: "render",
    value: function render() {
      var meta = this.props.meta;
      return /*#__PURE__*/React.createElement("ul", {
        className: compStyles.XRadioMeta
      }, _.map(meta, function (m) {
        return /*#__PURE__*/React.createElement("li", {
          className: compStyles.meta,
          key: m.label
        }, /*#__PURE__*/React.createElement("span", {
          className: compStyles.label
        }, m.label), /*#__PURE__*/React.createElement("span", {
          className: compStyles.value
        }, m.value), /*#__PURE__*/React.createElement("span", {
          className: compStyles.more
        }, "+12 more"));
      }));
    }
  }]);

  return XRadioMeta;
}(React.Component);

module.exports = XRadioMeta;