var _classCallCheck = require("@babel/runtime/helpers/classCallCheck");

var _createClass = require("@babel/runtime/helpers/createClass");

var _assertThisInitialized = require("@babel/runtime/helpers/assertThisInitialized");

var _inherits = require("@babel/runtime/helpers/inherits");

var _possibleConstructorReturn = require("@babel/runtime/helpers/possibleConstructorReturn");

var _getPrototypeOf = require("@babel/runtime/helpers/getPrototypeOf");

var _defineProperty = require("@babel/runtime/helpers/defineProperty");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var React = require('react');

var _ = require('./underscore_ext')["default"]; // Styles


var compStyles = require('./ChartView.module.css');

var ChartView = /*#__PURE__*/function (_React$Component) {
  "use strict";

  _inherits(ChartView, _React$Component);

  var _super = _createSuper(ChartView);

  function ChartView() {
    var _this;

    _classCallCheck(this, ChartView);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "setSize", function () {
      if (_this.chart) {
        var height = _this.chart.chartHeight(),
            width = _this.chart.chartWidth();

        document.getElementById("myChart").style.height = height;
        document.getElementById("myChart").style.width = width;
        document.getElementById("controlPanel").style.width = width;
      }
    });

    _defineProperty(_assertThisInitialized(_this), "chartRender", function (props) {
      var appState = props.appState,
          callback = props.callback,
          root = _this.refs.root;

      require.ensure(['./chart'], function () {
        _this.chart = require('./chart');
        root.innerHTML = '';
        _this.destroy = _this.chart.render(root, callback, {
          xena: JSON.stringify(appState)
        });
      });
    });

    return _this;
  }

  _createClass(ChartView, [{
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate() {
      return false;
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.chartRender(this.props);
      window.addEventListener('resize', this.setSize);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      window.removeEventListener('resize', this.setSize);

      if (this.destroy) {
        this.destroy();
      }
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(newProps) {
      // Updating this way is clumsy. Need to refactor chart view.
      if (!_.isEqual(_.omit(this.props.appState, 'chartState'), _.omit(newProps.appState, 'chartState'))) {
        this.chartRender(newProps);
      }
    }
  }, {
    key: "render",
    value: function render() {
      return /*#__PURE__*/React.createElement("div", {
        ref: "root",
        className: compStyles.ChartView
      });
    }
  }]);

  return ChartView;
}(React.Component);

module.exports = ChartView;