"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _PureComponent2 = _interopRequireDefault(require("../PureComponent"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var React = require('react');

var classNames = require('classnames');

var ColumnAdd = require('../views/ColumnAdd'); // Styles


var compStyles = require('./addColumnAdd.module.css');

var hoverClass = function hoverClass(index, hover) {
  return index === hover ? compStyles.hoverLeft : index - 1 === hover ? compStyles.hoverRight : undefined;
}; // XXX move layout to a view, after we know what the final layout will be.


function addColumnAdd(Component) {
  var _class, _temp;

  return _temp = _class = /*#__PURE__*/function (_PureComponent) {
    (0, _inherits2["default"])(_class, _PureComponent);

    var _super = _createSuper(_class);

    function _class() {
      var _this;

      (0, _classCallCheck2["default"])(this, _class);

      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      _this = _super.call.apply(_super, [this].concat(args));
      (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "state", {
        hover: null
      });
      (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onClick", function (index) {
        _this.props.onAddColumn(index);

        _this.setState({
          hover: null
        });
      });
      (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onHover", function (index, hovering) {
        if (index === 0) {
          _this.props.callback(['enableTransition', true]);

          _this.props.callback(['addColumnAddHover', hovering]);
        }

        _this.setState({
          hover: hovering ? index : null
        });
      });
      return _this;
    }

    (0, _createClass2["default"])(_class, [{
      key: "render",
      value: function render() {
        var _this2 = this;

        var _this$props = this.props,
            children = _this$props.children,
            otherProps = (0, _objectWithoutProperties2["default"])(_this$props, ["children"]),
            wizardMode = otherProps.appState.wizardMode,
            interactive = otherProps.interactive,
            hover = this.state.hover,
            lastIndex = children.length - 1,
            columns = React.Children.map(children, function (child, i) {
          return /*#__PURE__*/React.createElement("div", {
            className: classNames(compStyles.visualizationOrWizardMode, hoverClass(i, hover), (0, _defineProperty2["default"])({}, compStyles.wizardModeMargins, wizardMode)),
            "data-actionKey": child.props.actionKey
          }, child, /*#__PURE__*/React.createElement(ColumnAdd, {
            show: interactive,
            actionKey: i,
            last: i === lastIndex,
            onHover: _this2.onHover,
            onClick: _this2.onClick
          }));
        });
        return /*#__PURE__*/React.createElement(Component, otherProps, columns);
      }
    }]);
    return _class;
  }(_PureComponent2["default"]), (0, _defineProperty2["default"])(_class, "displayName", 'SpreadsheetColumnAdd'), _temp;
}

module.exports = addColumnAdd;