var _objectWithoutProperties = require("@babel/runtime/helpers/objectWithoutProperties");

var _classCallCheck = require("@babel/runtime/helpers/classCallCheck");

var _createClass = require("@babel/runtime/helpers/createClass");

var _assertThisInitialized = require("@babel/runtime/helpers/assertThisInitialized");

var _inherits = require("@babel/runtime/helpers/inherits");

var _possibleConstructorReturn = require("@babel/runtime/helpers/possibleConstructorReturn");

var _getPrototypeOf = require("@babel/runtime/helpers/getPrototypeOf");

var _defineProperty = require("@babel/runtime/helpers/defineProperty");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var React = require('react');

var HelpBox = require('../views/HelpBox'); //old text:  The left-most column is used for the initial row sort. In case of a tie, the value in the next column to the right is used to break the tie.


var columnHelp = function columnHelp(onClose) {
  return /*#__PURE__*/React.createElement(HelpBox, {
    w: 400,
    o: "Below",
    onClose: onClose
  }, /*#__PURE__*/React.createElement("p", null, "Column B value is used to sort the rows. In case of a tie, the next columns to the right are used to break the tie."));
};

var rowHelp = function rowHelp(onClose) {
  return /*#__PURE__*/React.createElement(HelpBox, {
    w: 400,
    o: "Right",
    onClose: onClose
  }, /*#__PURE__*/React.createElement("p", null, "Each row contains data from a single sample."), /*#__PURE__*/React.createElement("p", null, "Row order is determined by sorting the rows by their column values."));
};

function addHelp(Component) {
  var _class, _temp;

  return _temp = _class = /*#__PURE__*/function (_React$Component) {
    "use strict";

    _inherits(_class, _React$Component);

    var _super = _createSuper(_class);

    function _class() {
      var _this;

      _classCallCheck(this, _class);

      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      _this = _super.call.apply(_super, [this].concat(args));

      _defineProperty(_assertThisInitialized(_this), "onColumnHelp", function () {
        _this.props.callback(['notifications-disable', 'columnHelp']);
      });

      _defineProperty(_assertThisInitialized(_this), "onRowHelp", function () {
        _this.props.callback(['notifications-disable', 'rowHelp']);
      });

      return _this;
    }

    _createClass(_class, [{
      key: "render",
      value: function render() {
        var _this2 = this;

        var _this$props = this.props,
            children = _this$props.children,
            props = _objectWithoutProperties(_this$props, ["children"]),
            _this$props$appState = this.props.appState,
            columnOrder = _this$props$appState.columnOrder,
            notifications = _this$props$appState.notifications,
            wizardMode = _this$props$appState.wizardMode,
            last = columnOrder.length - 1;

        return /*#__PURE__*/React.createElement(Component, props, React.Children.map(children, function (el, i) {
          var append = wizardMode ? undefined : i === 1 && !notifications.columnHelp ? columnHelp(_this2.onColumnHelp) : i === last && !notifications.rowHelp ? rowHelp(_this2.onRowHelp) : undefined;
          return append ? React.cloneElement(el, {
            append: append
          }) : el;
        }));
      }
    }]);

    return _class;
  }(React.Component), _defineProperty(_class, "displayName", 'SpreadsheetHelp'), _temp;
}

module.exports = addHelp;