var _defineProperty = require("@babel/runtime/helpers/defineProperty");

var _slicedToArray = require("@babel/runtime/helpers/slicedToArray");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var _ = require('../underscore_ext')["default"];

var canEdit = function canEdit(_ref) {
  var _ref2 = _slicedToArray(_ref, 1),
      type = _ref2[0];

  return type === 'geneSignature';
};

function supportsEdit(fs) {
  return fs.fetchType === 'signature' ? canEdit(fs.signature) : true;
}

var setFieldType = _.curry(function (type, fs) {
  return _.assoc(fs, 'fieldType', type);
});

var signatureField = function signatureField(fieldName, opts) {
  return _objectSpread({
    fetchType: 'signature',
    valueType: 'float',
    fieldType: 'clinical',
    colorClass: 'clinical',
    fields: [fieldName],
    columnLabel: 'signature',
    fieldLabel: fieldName
  }, opts);
};

module.exports = {
  setFieldType: setFieldType,
  signatureField: signatureField,
  supportsEdit: supportsEdit
};