var fmapMemoize1 = require('./underscore_ext')["default"].fmapMemoize1; // should be just one dependency, which returns an object.


function createFmapSelector(selector, resultFn) {
  var resultFunc = fmapMemoize1(resultFn); // XXX add recalc counter?

  return function (state, props) {
    for (var _len = arguments.length, args = new Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
      args[_key - 2] = arguments[_key];
    }

    return resultFunc(selector.apply(void 0, [state, props].concat(args)));
  };
}

module.exports = {
  createFmapSelector: createFmapSelector
};