var _defineProperty = require("@babel/runtime/helpers/defineProperty");

var _classCallCheck = require("@babel/runtime/helpers/classCallCheck");

var _createClass = require("@babel/runtime/helpers/createClass");

var _inherits = require("@babel/runtime/helpers/inherits");

var _possibleConstructorReturn = require("@babel/runtime/helpers/possibleConstructorReturn");

var _getPrototypeOf = require("@babel/runtime/helpers/getPrototypeOf");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

/**
 * UCSC Xena Client
 * http://xena.ucsc.edu
 *
 * Avatar displayed at top of wizard, col (visualization) and ghost cards. If ID is specified, avatar is shaded with
 * with grey background, otherwise avatar is displayed hollow with a dashed border.
 *
 * State
 * -----
 * colId - ID of column (eg 'A', 'B').
 */
// Core dependencies, components
var React = require('react');

var classNames = require('classnames'); // Styles


var compStyles = require('./CardAvatar.module.css');

var CardAvatar = /*#__PURE__*/function (_React$Component) {
  "use strict";

  _inherits(CardAvatar, _React$Component);

  var _super = _createSuper(CardAvatar);

  function CardAvatar() {
    _classCallCheck(this, CardAvatar);

    return _super.apply(this, arguments);
  }

  _createClass(CardAvatar, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          colId = _this$props.colId,
          zoomCard = _this$props.zoomCard,
          ghost = !colId,
          noAvatar = zoomCard;
      return /*#__PURE__*/React.createElement("div", {
        className: classNames(_defineProperty({}, compStyles.avatar, !noAvatar), _defineProperty({}, compStyles.ghost, ghost), _defineProperty({}, compStyles.noAvatar, noAvatar))
      }, colId);
    }
  }]);

  return CardAvatar;
}(React.Component);

module.exports = CardAvatar;