"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _CohortSuggest = require("../views/CohortSuggest");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var React = require('react');

var DiseaseSuggest = require('./DiseaseSuggest2');

var XRadioGroup = require('./XRadioGroup');

var WizardCard = require('./WizardCard');

var CohortOrDisease = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(CohortOrDisease, _React$Component);

  var _super = _createSuper(CohortOrDisease);

  function CohortOrDisease() {
    var _this;

    (0, _classCallCheck2["default"])(this, CohortOrDisease);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "state", {
      mode: 'cohort',
      cohort: null
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onChange", function (value) {
      _this.setState({
        mode: value,
        cohort: null
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onDone", function () {
      _this.props.onSelect(_this.state.cohort);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onSelect", function (cohort) {
      _this.setState({
        cohort: cohort
      });
    });
    return _this;
  }

  (0, _createClass2["default"])(CohortOrDisease, [{
    key: "render",
    value: function render() {
      var _this$state = this.state,
          mode = _this$state.mode,
          cohort = _this$state.cohort,
          _this$props = this.props,
          _this$props$cohorts = _this$props.cohorts,
          cohorts = _this$props$cohorts === void 0 ? [] : _this$props$cohorts,
          cohortMeta = _this$props.cohortMeta,
          width = _this$props.width;
      var studyDiscoveryProps = {
        label: 'Study Discovery',
        value: mode,
        onChange: this.onChange,
        options: [{
          label: 'Help me select a study',
          value: 'disease'
        }, {
          label: 'I know the study I want to use',
          value: 'cohort'
        }]
      };
      var wizardProps = {
        title: 'Study',
        helpText: 'If you would like help determining the data set to use, Xena can suggest data sets if you provide a primary disease or tissue of origin.',
        onDone: this.onDone,
        valid: !!cohort,
        width: width
      };
      return /*#__PURE__*/React.createElement(WizardCard, wizardProps, /*#__PURE__*/React.createElement(XRadioGroup, studyDiscoveryProps), mode === 'cohort' ? /*#__PURE__*/React.createElement(_CohortSuggest.CohortSuggest, {
        onSelect: this.onSelect,
        cohorts: cohorts,
        cohort: cohort
      }) : /*#__PURE__*/React.createElement(DiseaseSuggest, {
        onSelect: this.onSelect,
        cohorts: cohorts,
        cohort: cohort,
        cohortMeta: cohortMeta
      }));
    }
  }]);
  return CohortOrDisease;
}(React.Component);

module.exports = CohortOrDisease;