"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _PureComponent2 = _interopRequireDefault(require("../PureComponent"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var omit = require('../underscore_ext')["default"].omit;

var React = require('react');

var ColumnsWrapper = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(ColumnsWrapper, _React$Component);

  var _super = _createSuper(ColumnsWrapper);

  function ColumnsWrapper() {
    (0, _classCallCheck2["default"])(this, ColumnsWrapper);
    return _super.apply(this, arguments);
  }

  (0, _createClass2["default"])(ColumnsWrapper, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          children = _this$props.children,
          append = _this$props.append,
          onClick = _this$props.onClick;
      return /*#__PURE__*/React.createElement("div", {
        onClick: onClick,
        className: "Columns"
      }, children, append);
    }
  }]);
  return ColumnsWrapper;
}(React.Component);

var getColumns = function getColumns(wrapperFn) {
  var _class, _temp;

  var Wrapper = wrapperFn(ColumnsWrapper);
  return _temp = _class = /*#__PURE__*/function (_PureComponent) {
    (0, _inherits2["default"])(_class, _PureComponent);

    var _super2 = _createSuper(_class);

    function _class() {
      (0, _classCallCheck2["default"])(this, _class);
      return _super2.apply(this, arguments);
    }

    (0, _createClass2["default"])(_class, [{
      key: "render",
      value: function render() {
        var children = this.props.children,
            wrapperProps = omit(this.props, 'onClick', 'children');
        return /*#__PURE__*/React.createElement(Wrapper, wrapperProps, children);
      }
    }]);
    return _class;
  }(_PureComponent2["default"]), (0, _defineProperty2["default"])(_class, "displayName", 'SpreadsheetColumns'), _temp;
};

module.exports = getColumns;