var _classCallCheck = require("@babel/runtime/helpers/classCallCheck");

var _createClass = require("@babel/runtime/helpers/createClass");

var _assertThisInitialized = require("@babel/runtime/helpers/assertThisInitialized");

var _inherits = require("@babel/runtime/helpers/inherits");

var _possibleConstructorReturn = require("@babel/runtime/helpers/possibleConstructorReturn");

var _getPrototypeOf = require("@babel/runtime/helpers/getPrototypeOf");

var _defineProperty = require("@babel/runtime/helpers/defineProperty");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var React = require('react');

var Resizable = require('react-resizable').Resizable;

var _ = require('../underscore_ext')["default"]; // Styles


require('./ResizeOverlay.css');

var max = function max(x, y) {
  return x > y ? x : y;
};

var minWidthSize = function minWidthSize(minWidth, _ref) {
  var width = _ref.width,
      height = _ref.height;
  return {
    width: max(minWidth, width),
    height: height
  };
};

var ResizeOverlay = /*#__PURE__*/function (_React$Component) {
  "use strict";

  _inherits(ResizeOverlay, _React$Component);

  var _super = _createSuper(ResizeOverlay);

  function ResizeOverlay() {
    var _this;

    _classCallCheck(this, ResizeOverlay);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "state", {
      zooming: false
    });

    _defineProperty(_assertThisInitialized(_this), "onResizeStart", function () {
      var _this$props = _this.props,
          width = _this$props.width,
          height = _this$props.height,
          minWidth = _this.props.minWidth();

      _this.setState({
        zooming: true,
        zoomSize: {
          width: width,
          height: height
        },
        minWidth: minWidth
      });
    });

    _defineProperty(_assertThisInitialized(_this), "onResize", function (ev, _ref2) {
      var size = _ref2.size;
      var width = size.width,
          height = size.height,
          minWidth = _this.state.minWidth;

      _this.setState({
        zoomSize: {
          width: max(width, minWidth),
          height: height
        }
      });
    });

    _defineProperty(_assertThisInitialized(_this), "onResizeStop", function (ev, _ref3) {
      var size = _ref3.size;
      var onResizeStop = _this.props.onResizeStop,
          minWidth = _this.state.minWidth;

      _this.setState({
        zooming: false
      });

      if (onResizeStop) {
        onResizeStop(minWidthSize(minWidth, size));
      }
    });

    return _this;
  }

  _createClass(ResizeOverlay, [{
    key: "render",
    value: function render() {
      var _this$state = this.state,
          zooming = _this$state.zooming,
          zoomSize = _this$state.zoomSize,
          _this$props2 = this.props,
          width = _this$props2.width,
          height = _this$props2.height,
          children = _this$props2.children,
          enable = _this$props2.enable,
          content = /*#__PURE__*/React.createElement("div", {
        style: {
          position: 'relative',
          cursor: 'none',
          zIndex: 0
        }
      }, children);
      return /*#__PURE__*/React.createElement("div", {
        className: enable ? 'resize-enable' : '',
        style: {
          position: 'relative'
        }
      }, /*#__PURE__*/React.createElement("div", {
        style: {
          display: zooming ? 'block' : 'none',
          width: _.get(zoomSize, 'width', 0),
          height: _.get(zoomSize, 'height', 0),
          position: 'absolute',
          top: 0,
          left: 0,
          zIndex: 999,
          backgroundColor: 'rgba(0, 0, 0, 0.12)'
        }
      }), /*#__PURE__*/React.createElement(Resizable, {
        handleSize: [20, 20],
        axis: 'both',
        onResizeStop: this.onResizeStop,
        onResize: this.onResize,
        onResizeStart: this.onResizeStart,
        width: width,
        height: height
      }, content));
    }
  }]);

  return ResizeOverlay;
}(React.Component);

module.exports = ResizeOverlay;