"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SampleSearch = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _PureComponent2 = _interopRequireDefault(require("../PureComponent"));

var _input = _interopRequireDefault(require("react-toolbox/lib/input"));

var _menu = require("react-toolbox/lib/menu");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var React = require('react');

var classNames = require('classnames');

var Rx = require('../rx')["default"]; // Styles


var compStyles = require('./SampleSearch.module.css'); //var SampleIDInput = React.createClass({
//	getInitialState() {
//		return {
//			show: false,
//			value: undefined
//		};
//	},
//	onChange (ev) {
//		var value = ev.target.value;
//		this.setState({value});
//	},
//	close () {
//		this.setState({ show: false});
//	},
//	submit () {
//		var samplesList = this.state.value.split(/\s+/),
//			{onSearchIDAndFilterColumn, onSamplesSubmit} = this.props;
//		this.close();
//		this.state.value = '';
//		onSearchIDAndFilterColumn(samplesList);
//		onSamplesSubmit("A:true"); // since the new column is always column A
//	},
//	render() {
//		var tooltipButton = <Tooltip>Search by sample IDs</Tooltip>,
//			tooltipModalString = 'Samples match your list will be highlighted. \
//				A new binary column will be made using your list: matched samples vs. the rest.',
//			tooltipModal = <Tooltip>{tooltipModalString}</Tooltip>,
//			{cohortSamples, disabled} = this.props,
//			help = 'e.g.\n' + Object.values(cohortSamples)[0].slice(0, 5).join('\n') + '\n...';
//
//		return (
//			<span className = "modal-container" >
//				<OverlayTrigger trigger={['hover']} placement="top" overlay={tooltipButton}>
//					<Button
//						bsSize = "small"
//						onClick = {() => this.setState({ show: true})}
//						disabled={disabled}>
//						Custom Sample List
//					</Button>
//				</OverlayTrigger>
//				<Modal
//					show={this.state.show}
//					onHide={this.close}
//					container={this}
//					aria-labelledby="contained-modal-title">
//					<Modal.Header closeButton>
//						<Modal.Title id="contained-modal-title">
//							Enter a list of samaple IDs to highlight
//							<OverlayTrigger trigger={['hover']} placement="right" overlay={tooltipModal}>
//								<span className='glyphicon glyphicon-info-sign text-muted'
//									style={{margin: '5px'}}/>
//							</OverlayTrigger>
//						</Modal.Title>
//					</Modal.Header>
//					<Modal.Body>
//						<Input style={{width: 550, height: 200}}
//							value={this.state.value}
//							type ="textarea"
//							placeholder={help}
//							onChange={this.onChange}/>
//					</Modal.Body>
//					<Modal.Footer>
//						<Button bsStyle="primary" onClick={this.submit} disabled={!this.state.value}>Submit</Button>
//						<Button onClick={this.close}>Cancel</Button>
//					</Modal.Footer>
//				</Modal>
//			</span>
//		);
//	}
//});


function countChar(str, c, max) {
  var count = 0;

  for (var i = 0; i < max; ++i) {
    if (str[i] === c) {
      count += 1;
    }
  }

  return count;
}

var SampleSearch = /*#__PURE__*/function (_PureComponent) {
  (0, _inherits2["default"])(SampleSearch, _PureComponent);

  var _super = _createSuper(SampleSearch);

  function SampleSearch() {
    var _this;

    (0, _classCallCheck2["default"])(this, SampleSearch);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "state", {
      value: _this.props.value
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onChange", function (value) {
      var onChange = _this.props.onChange;

      _this.setState({
        value: value
      });

      onChange(value);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onSamplesSubmit", function (value) {
      var onChange = _this.props.onChange;

      _this.setState({
        value: value
      });

      onChange(value);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "setRef", function (ref) {
      _this.input = ref && ref.inputNode;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onCaret", function () {
      var hl = _this.input ? countChar(_this.state.value, ';', _this.input.selectionStart) : undefined;

      _this.highlight(hl);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onHideCaret", function () {
      _this.highlight(undefined);
    });
    return _this;
  }

  (0, _createClass2["default"])(SampleSearch, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      var highlight = new Rx.Subject();
      this.highlight = highlight.next.bind(highlight);
      this.sub = highlight.startWith(undefined).distinctUntilChanged().subscribe(function (hl) {
        return _this2.props.onHighlightSelect(hl);
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.sub.unsubscribe();
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(newProps) {
      if (this.state.value === this.props.value) {
        this.setState({
          value: newProps.value
        });
      } // otherwise we have buffered changes to state, and
      // updating from props would revert the user input
      // and move the carat to the end.

    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          matches = _this$props.matches,
          sampleCount = _this$props.sampleCount,
          onFilter = _this$props.onFilter,
          onZoom = _this$props.onZoom,
          onCreateColumn = _this$props.onCreateColumn,
          onResetSampleFilter = _this$props.onResetSampleFilter,
          mode = _this$props.mode,
          value = this.state.value,
          disableActions = !(matches > 0 && matches < sampleCount),
          noshow = mode !== "heatmap";
      return /*#__PURE__*/React.createElement("div", {
        className: compStyles.SampleSearch
      }, /*#__PURE__*/React.createElement(_input["default"], {
        className: compStyles.inputContainer,
        onKeyUp: this.onCaret,
        onClick: this.onCaret,
        onFocus: this.onCaret,
        onBlur: this.onHideCaret,
        innerRef: this.setRef,
        spellCheck: false,
        type: "text",
        value: value || '',
        title: value,
        placeholder: "Find samples e.g. TCGA-DB-A4XH, missense",
        onChange: this.onChange,
        disabled: noshow
      }, /*#__PURE__*/React.createElement("span", {
        className: compStyles.subtitle
      }, "".concat(matches, " matching samples"))), noshow ? /*#__PURE__*/React.createElement("i", {
        className: classNames('material-icons', compStyles.menuDisabled)
      }, "filter_list") : /*#__PURE__*/React.createElement(_menu.IconMenu, {
        title: "Filter actions",
        className: compStyles.filterMenu,
        icon: "filter_list",
        iconRipple: false,
        position: "topLeft"
      }, /*#__PURE__*/React.createElement(_menu.MenuItem, {
        disabled: disableActions,
        caption: "Filter",
        onClick: onFilter
      }), /*#__PURE__*/React.createElement(_menu.MenuItem, {
        caption: "Clear Filter",
        onClick: onResetSampleFilter
      }), /*#__PURE__*/React.createElement(_menu.MenuItem, {
        disabled: disableActions,
        caption: "Zoom",
        onClick: onZoom
      }), /*#__PURE__*/React.createElement(_menu.MenuItem, {
        disabled: disableActions,
        caption: "New Column",
        onClick: onCreateColumn
      })));
    }
  }]);
  return SampleSearch;
}(_PureComponent2["default"]);

exports.SampleSearch = SampleSearch;