"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _PureComponent2 = _interopRequireDefault(require("../PureComponent"));

var _ConceptSuggest = _interopRequireDefault(require("./ConceptSuggest"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var React = require('react');

var _require$default = require('../underscore_ext')["default"],
    times = _require$default.times,
    mapObject = _require$default.mapObject,
    values = _require$default.values;

var styles = {
  section: {
    borderTop: '1px solid black'
  },
  doc: {
    marginTop: 0,
    marginBottom: 0,
    cursor: 'pointer'
  },
  show: {
    backgroundColor: '#EEEEFF'
  }
};

var setKey = function setKey(arr) {
  return arr.map(function (el, i) {
    return React.cloneElement(el, {
      key: i
    });
  });
};

var pageSizes = [10, 20, 50, 100];

var filterIcon = function filterIcon(hasDoc, filter) {
  return !hasDoc ? '-' : filter == null ? "\xA0" : filter ? 'y' : 'n';
};

var Ties = /*#__PURE__*/function (_PureComponent) {
  (0, _inherits2["default"])(Ties, _PureComponent);

  var _super = _createSuper(Ties);

  function Ties() {
    var _this;

    (0, _classCallCheck2["default"])(this, Ties);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onForward", function () {
      var _this$props = _this.props,
          onPage = _this$props.onPage,
          _this$props$state$tie = _this$props.state.ties.page,
          i = _this$props$state$tie.i,
          n = _this$props$state$tie.n;
      onPage({
        i: i + 1,
        n: n
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onBack", function () {
      var _this$props2 = _this.props,
          onPage = _this$props2.onPage,
          _this$props2$state$ti = _this$props2.state.ties.page,
          i = _this$props2$state$ti.i,
          n = _this$props2$state$ti.n;
      onPage({
        i: i - 1,
        n: n
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onPage", function (ev) {
      var i = parseInt(ev.target.value, 10) - 1,
          _this$props3 = _this.props,
          onPage = _this$props3.onPage,
          n = _this$props3.state.ties.page.n;
      onPage({
        i: i,
        n: n
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onPageSize", function (ev) {
      var _this$props4 = _this.props,
          onPage = _this$props4.onPage,
          page = _this$props4.state.ties.page,
          n = parseInt(ev.target.value, 10),
          i = Math.floor(page.n * page.i / n);
      onPage({
        i: i,
        n: n
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onShowDoc", function (ev) {
      var index = parseInt(ev.target.dataset.index, 10);

      _this.props.onShowDoc(index);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onKeepRow", function (ev) {
      var keep = ev.target.dataset.keep === 'true',
          _this$props5 = _this.props,
          onKeepRow = _this$props5.onKeepRow,
          showDoc = _this$props5.state.ties.showDoc;
      onKeepRow(showDoc, keep);
    });
    return _this;
  }

  (0, _createClass2["default"])(Ties, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props6 = this.props,
          onHideDoc = _this$props6.onHideDoc,
          onAddTerm = _this$props6.onAddTerm,
          state = _this$props6.state,
          _state$ties = state.ties,
          _state$ties$terms = _state$ties.terms,
          terms = _state$ties$terms === void 0 ? [] : _state$ties$terms,
          docs = _state$ties.docs,
          _state$ties$matches = _state$ties.matches,
          matches = _state$ties$matches === void 0 ? {} : _state$ties$matches,
          filter = _state$ties.filter,
          showDoc = _state$ties.showDoc,
          doc = _state$ties.doc,
          page = _state$ties.page,
          _state$ties$concepts = _state$ties.concepts,
          concepts = _state$ties$concepts === void 0 ? [] : _state$ties$concepts,
          pageCount = Math.ceil((docs || []).length / page.n),
          byTerm = mapObject(matches, function (_ref) {
        var matches = _ref.matches;
        return new Set(matches);
      }); // XXX put in selector

      return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("p", {
        style: styles.section
      }, /*#__PURE__*/React.createElement("button", {
        onClick: this.props.onDismiss
      }, "dismiss")), /*#__PURE__*/React.createElement("div", {
        style: styles.section
      }, "Terms: ", terms.map(function (t) {
        return matches[t] ? t : "".concat(t, " (loading)");
      }).join(', '), " ", /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement(_ConceptSuggest["default"], {
        onAddTerm: onAddTerm,
        concepts: concepts
      })), /*#__PURE__*/React.createElement("p", {
        style: styles.section
      }, "Filter", /*#__PURE__*/React.createElement("br", null), "Keep ", values(filter).filter(function (v) {
        return v === true;
      }).length, /*#__PURE__*/React.createElement("br", null), "Drop ", values(filter).filter(function (v) {
        return v === false;
      }).length), /*#__PURE__*/React.createElement("p", {
        style: styles.section
      }, "showDoc ", showDoc, showDoc && /*#__PURE__*/React.createElement("button", {
        onClick: onHideDoc
      }, "hide"), /*#__PURE__*/React.createElement("br", null), showDoc && /*#__PURE__*/React.createElement("button", {
        "data-keep": true,
        onClick: this.onKeepRow
      }, "keep"), /*#__PURE__*/React.createElement("br", null), showDoc && /*#__PURE__*/React.createElement("button", {
        "data-keep": false,
        onClick: this.onKeepRow
      }, "discard"), /*#__PURE__*/React.createElement("br", null), "doc ", doc && doc.id, " ", doc && doc.text.slice(0, 100)), /*#__PURE__*/React.createElement("div", {
        style: styles.section
      }, "Page", /*#__PURE__*/React.createElement("select", {
        value: page.i + 1,
        onChange: this.onPage
      }, times(pageCount, function (i) {
        return /*#__PURE__*/React.createElement("option", {
          key: i,
          value: i + 1
        }, i + 1);
      })), /*#__PURE__*/React.createElement("button", {
        disabled: page.i === 0,
        onClick: this.onBack
      }, "<"), /*#__PURE__*/React.createElement("button", {
        disabled: page.i > pageCount - 2,
        onClick: this.onForward
      }, ">"), /*#__PURE__*/React.createElement("br", null), "Page length", /*#__PURE__*/React.createElement("select", {
        value: page.n,
        onChange: this.onPageSize
      }, pageSizes.map(function (s) {
        return /*#__PURE__*/React.createElement("option", {
          key: s,
          value: s
        }, s);
      })), /*#__PURE__*/React.createElement("br", null), "showing ", page.i * page.n, " - ", (page.i + 1) * page.n - 1, /*#__PURE__*/React.createElement("br", null), docs ? setKey(docs.slice(page.i * page.n, (page.i + 1) * page.n).map(function (_ref2, i) {
        var patient = _ref2.patient,
            doc = _ref2.doc;
        return /*#__PURE__*/React.createElement("p", {
          style: _objectSpread(_objectSpread({}, styles.doc), page.i * page.n + i === showDoc ? styles.show : {}),
          "data-index": page.i * page.n + i,
          onClick: doc ? _this2.onShowDoc : undefined
        }, filterIcon(doc, filter[page.i * page.n + i]), ' ', patient, ": ", doc, " ", terms.map(function (t) {
          return byTerm[t] && byTerm[t].has(patient) ? t : '';
        }).join(' '));
      })) : "loading docs..."));
    }
  }]);
  return Ties;
}(_PureComponent2["default"]);

var _default = Ties;
exports["default"] = _default;