"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _WelcomeModule = _interopRequireDefault(require("./Welcome.module.css"));

var _typographyModule = _interopRequireDefault(require("../../css/typography.module.css"));

var _iconXena = _interopRequireDefault(require("../../images/iconXena.png"));

var _iconXena2x = _interopRequireDefault(require("../../images/iconXena@2x.png"));

var _iconXena3x = _interopRequireDefault(require("../../images/iconXena@3x.png"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var times = require('./../underscore_ext')["default"].times; // Styles


var welcomeSrcSet = "".concat(_iconXena2x["default"], " 2x, ").concat(_iconXena3x["default"], " 3x");

var Welcome = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(Welcome, _Component);

  var _super = _createSuper(Welcome);

  function Welcome() {
    var _this;

    (0, _classCallCheck2["default"])(this, Welcome);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "dismissWelcome", function () {
      _this.props.onClick();
    });
    return _this;
  }

  (0, _createClass2["default"])(Welcome, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          _this$props$link = (0, _slicedToArray2["default"])(_this$props.link, 3),
          app = _this$props$link[0],
          bookmark = _this$props$link[1],
          text = _this$props$link[2],
          count = _this$props.count,
          i = _this$props.i,
          linkProps = _this$props.linkProps,
          bulletProps = _this$props.bulletProps,
          link = "".concat(document.location.origin, "/").concat(app, "/?bookmark=").concat(bookmark);

      return /*#__PURE__*/_react["default"].createElement("div", {
        className: _WelcomeModule["default"].Welcome
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: _WelcomeModule["default"].welcomeIcon
      }, /*#__PURE__*/_react["default"].createElement("img", {
        className: _WelcomeModule["default"].imgXena,
        src: _iconXena["default"],
        srcSet: welcomeSrcSet
      })), /*#__PURE__*/_react["default"].createElement("div", {
        className: _WelcomeModule["default"].welcomeText
      }, /*#__PURE__*/_react["default"].createElement("h1", {
        className: _typographyModule["default"].mdHeadline
      }, "Welcome to the Xena Functional Genomics Explorer"), /*#__PURE__*/_react["default"].createElement("h2", {
        className: _typographyModule["default"].mdSubhead
      }, "UCSC Xena allows users to explore functional genomic data sets for correlations between genomic and/or phenotypic variables."), /*#__PURE__*/_react["default"].createElement("h2", {
        className: _typographyModule["default"].mdSubhead
      }, "View live example: ", /*#__PURE__*/_react["default"].createElement("a", (0, _extends2["default"])({}, linkProps, {
        href: link,
        target: "_blank"
      }), text)), /*#__PURE__*/_react["default"].createElement("div", {
        className: _WelcomeModule["default"].bulletWrapper
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: _WelcomeModule["default"].bullets
      }, times(count, function (j) {
        return /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({
          key: j,
          "data-index": j
        }, bulletProps, {
          className: i === j ? _WelcomeModule["default"].bulletActive : _WelcomeModule["default"].bullet
        }), "\u2022");
      })))), /*#__PURE__*/_react["default"].createElement("div", {
        className: _WelcomeModule["default"].closeIcon,
        onClick: this.dismissWelcome
      }, /*#__PURE__*/_react["default"].createElement("i", {
        className: "material-icons"
      }, "close")));
    }
  }]);
  return Welcome;
}(_react.Component);

module.exports = Welcome;