var _classCallCheck = require("@babel/runtime/helpers/classCallCheck");

var _createClass = require("@babel/runtime/helpers/createClass");

var _assertThisInitialized = require("@babel/runtime/helpers/assertThisInitialized");

var _inherits = require("@babel/runtime/helpers/inherits");

var _possibleConstructorReturn = require("@babel/runtime/helpers/possibleConstructorReturn");

var _getPrototypeOf = require("@babel/runtime/helpers/getPrototypeOf");

var _defineProperty = require("@babel/runtime/helpers/defineProperty");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

/**
 * UCSC Xena Client
 * http://xena.ucsc.edu
 *
 * Standard Xena input toolbar, displayed above radio group or checkbox group. Displays input field name and optionally,
 * an additional action with corresponding click handler.
 *
 * State
 * -----
 * - Label
 * - Additional Action
 *
 * Actions
 * -------
 * - onAdditionalAction
 */
// Core dependencies, components
var React = require('react'); // Styles


var compStyles = require('./XInputToolbar.module.css');

var XInputGroup = /*#__PURE__*/function (_React$Component) {
  "use strict";

  _inherits(XInputGroup, _React$Component);

  var _super = _createSuper(XInputGroup);

  function XInputGroup() {
    var _this;

    _classCallCheck(this, XInputGroup);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "onAdditionalAction", function (value) {
      _this.props.onAdditionalAction(value);
    });

    return _this;
  }

  _createClass(XInputGroup, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          additionalAction = _this$props.additionalAction,
          label = _this$props.label;
      return /*#__PURE__*/React.createElement("div", {
        className: compStyles.toolbar
      }, label ? /*#__PURE__*/React.createElement("span", {
        className: compStyles.label
      }, label) : null, additionalAction ? /*#__PURE__*/React.createElement("span", {
        className: compStyles.additionalAction,
        onClick: this.onAdditionalAction
      }, additionalAction) : null);
    }
  }]);

  return XInputGroup;
}(React.Component);

module.exports = XInputGroup;